unit MainForm;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, Math, Menus, TntStdCtrls, TNTForms, TNTClasses, StrUtils, TntSysUtils,
   TntButtons, ProcessViewer, TntCheckLst, TntComCtrls, CommCtrl, ShellApi, ActiveX, ComObj,
   ComCtrls, Buttons, xmldom, XMLIntf, msxmldom, XMLDoc, ImgList, Wininet, Dialogs, TNTClipbrd;

function GetEnvVarValue(const VarName: WideString): WideString;
function FindDriveWithID(const ID: AnsiString): ShortInt;
function GetDriveID(const aDrive: ShortInt): AnsiString;
function GetDriveSize(const Drive: Byte): Int64;
function GetDriveVendorAndProductID(const aDrive: Byte): AnsiString;
function GenGuid: AnsiString;
function GenID: AnsiString;
procedure Replacebks(var ws: WideString; const len: Integer);

type
   LastUsedIDS = record
      fdCID: AnsiString;
      fdGUID: AnsiString;
      sdCID: AnsiString;
      sdGUID: AnsiString;
   end;
   VMentry = record
      Name: WideString;
      Ptype: Byte;
      ModeLoadVM: Byte;
      VMID: WideString;
      VMName: WideString;
      VMPath: WideString;
      ExeParams: WideString;
      FirstDriveID: AnsiString;
      FirstDriveName: AnsiString;
      SecondDriveID: AnsiString;
      SecondDriveName: AnsiString;
      InternalHDD: WideString;
      CDROMName: WideString;
      CDROMType: Byte;
      Memory: Word;
      Audio: Byte;
      Run: Byte;
      Priority: Byte;
      luIDS: LastUsedIDS;
      VBCPUVirtualization: Byte;
   end;
   VolumeInfo = record
      Letter: AnsiChar;
      Handle: THandle;
      DriveProp: AnsiString;
   end;
   _STORAGE_DEVICE_NUMBER = record
      DeviceType: DWORD;
      DeviceNumber: DWORD;
      PartitionNumber: DWORD;
   end;
   STORAGE_DEVICE_NUMBER = _STORAGE_DEVICE_NUMBER;
   _GET_LENGTH_INFORMATION = record
      Length: Int64;
   end;
   TGetLengthInformation = _GET_LENGTH_INFORMATION;

type
   TfrmMain = class(TTNTForm)
      pmVMs: TPopupMenu;
      mmEdit: TMenuItem;
      mmDelete: TMenuItem;
      btnAdd: TTntSpeedButton;
      btnEdit: TTntSpeedButton;
      btnDelete: TTntSpeedButton;
      btnOptions: TTntSpeedButton;
      mmAdd: TMenuItem;
      btnExit: TTntSpeedButton;
      btnStart: TTntSpeedButton;
      xmlGen: TXMLDocument;
      xmlVBox: TXMLDocument;
      xmlVBoxCompare: TXMLDocument;
      lvVMs: TTntListView;
      pmHeaders: TPopupMenu;
      mmFirstDrive: TMenuItem;
      mmSecondDrive: TMenuItem;
      mmName: TMenuItem;
      mmCrt: TMenuItem;
      mmVMName: TMenuItem;
      imlV: TImageList;
      mmDown: TMenuItem;
      mmUp: TMenuItem;
      mmEnter: TMenuItem;
      mmEsc: TMenuItem;
      mmNumPlus: TMenuItem;
      mmMoveUp: TMenuItem;
      mmMoveDown: TMenuItem;
      mmEditH: TMenuItem;
      mmDeleteH: TMenuItem;
      mmMoveUpH: TMenuItem;
      mmMoveDownH: TMenuItem;
      mmHelp: TMenuItem;
      mmOptions: TMenuItem;
      procedure btnExitClick(Sender: TObject);
      procedure btnAddClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure btnEditClick(Sender: TObject);
      procedure btnDeleteClick(Sender: TObject);
      procedure MoveUp(Sender: TObject);
      procedure MoveDown(Sender: TObject);
      procedure btnStartClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure lvVMsDragDrop(Sender, Source: TObject; X, Y: Integer);
      procedure lvVMsDragOver(Sender, Source: TObject; X, Y: Integer;
         State: TDragState; var Accept: Boolean);
      procedure TntFormMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
      procedure WindProc(var Message: TMessage);
      procedure TntFormResize(Sender: TObject);
      procedure pmHeadersPopup(Sender: TObject);
      procedure mmHeadersClick(Sender: TObject);
      procedure lvVMsColumnClick(Sender: TObject; Column: TListColumn);
      procedure lvVMsContextPopup(Sender: TObject; MousePos: TPoint;
         var Handled: Boolean);
      procedure lvVMsCustomDrawSubItem(Sender: TCustomListView;
         Item: TListItem; SubItem: Integer; State: TCustomDrawState;
         var DefaultDraw: Boolean);
      procedure mmDownClick(Sender: TObject);
      procedure mmUpClick(Sender: TObject);
      procedure mmEnterClick(Sender: TObject);
      procedure mmEscClick(Sender: TObject);
      procedure mmNumPlusClick(Sender: TObject);
      procedure btnOptionsClick(Sender: TObject);
      procedure mmHelpClick(Sender: TObject);
      procedure mmOptionsClick(Sender: TObject);
      procedure OnException(Sender: TObject; E: Exception);
   private
      { Private declarations }
      procedure Sort(const ColumnIndex: Integer);
      procedure SortAfterType;
      procedure pmChangeMessageBox(var Msg: TMessage); message WM_USER + 1024;
   public
      { Public declarations }
      procedure LoadVMentries(const FileName: WideString);
      procedure SaveVMentries(const FileName: WideString);
      function LoadCFG(const FileName: WideString): Boolean;
      procedure SaveCFG(const FileName: WideString);
      function LockVolume(const vi: VolumeInfo): Boolean;
      procedure AppActDeactModBegModEnd(Sender: TObject);
      procedure OpenInternetHelp(const OwnerWindowHandle: THandle; const SiteHelp: array of WideString);
      function FindCDROMLetter(const CDROMName: AnsiString): Char;
   end;

const
   appVersion = ' 1.27';
   MAX_IDE_DRIVES = 16;
   METHOD_BUFFERED = 0;
   FILE_ANY_ACCESS = 0;
   FILE_DEVICE_FILE_SYSTEM = $00000009;
   FILE_DEVICE_MASS_STORAGE = $0000002D;
   IOCTL_STORAGE_BASE = FILE_DEVICE_MASS_STORAGE;
   IOCTL_STORAGE_GET_DEVICE_NUMBER = ((IOCTL_STORAGE_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or
      ($0420 shl 2) or METHOD_BUFFERED);
   FILE_READ_ACCESS = $00000001;
   IOCTL_DISK_BASE = $00000007;
   IOCTL_DISK_GET_LENGTH_INFO = ((IOCTL_DISK_BASE shl 16) or FILE_READ_ACCESS shl 14) or ($0017 shl 2) or METHOD_BUFFERED; { CTL_CODE }
   IOCTL_STORAGE_QUERY_PROPERTY = (IOCTL_STORAGE_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or ($0500 shl 2) or (METHOD_BUFFERED);
   IOCTL_DISK_UPDATE_PROPERTIES = ((IOCTL_DISK_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or ($0050 shl 2) or METHOD_BUFFERED);
   defvmdk: array[1..6] of AnsiString = ('# Disk DescriptorFile'#10'version=1'#10'CID=',
      #10'parentCID=ffffffff'#10'createType="fullDevice"'#10#10'# Extent description'#10'RW ',
      ' FLAT "\\.\PhysicalDrive',
      '" 0'#10#10'# The disk Data Base'#10'#DDB'#10#10'ddb.virtualHWVersion = "4"'#10'ddb.adapterType="ide"'#10'ddb.geometry.cylinders="',
      '"'#10'ddb.geometry.heads="16"'#10'ddb.geometry.sectors="63"'#10'ddb.uuid.image="',
      '"'#10'ddb.uuid.parent="00000000-0000-0000-0000-000000000000"'#10'ddb.uuid.modification="00000000-0000-0000-0000-000000000000"'#10'ddb.uuid.parentmodification="00000000-0000-0000-0000-000000000000"'#10'');
   DefSiteHelp: array[1..2] of WideString = ('http://reboot.pro/topic/18736-virtual-machine-usb-boot/',
      'http://reboot.pro/index.php?showtopic=18736');

var
   frmMain: TfrmMain;
   fOldTWndMethod: TWndMethod;
   VMentries: array of VMentry;
   VMentriesFile, CfgFile, psEntries, psCFG, ExeVBPath, ExeQPath: WideString;
   QEMUDefaultParameters: WideString = '-name "USB Boot Test" -boot c -m 512 -soundhw sb16';
   LastError: Integer;
   OSDrive: Byte;
   MainLeft, MainTop, MainHeight, MainWidth, IntLeft, IntTop, IntHeight, IntWidth: Integer;
   MainMaximized: Boolean;
   DriveMessageShowed: Boolean = False;
   StartMessageShowed: Boolean = False;
   AddSecondDrive: Boolean = False;
   LockVolumes: Boolean = True;
   LastSelected: Integer = 0;
   UpdateVM: Byte = 0;
   isInstalledVersion: Boolean;
   Randomized: Boolean = False;
   VolumesInfo: array of VolumeInfo;
   ShowingProgress, ProgressCancelled, MainActivated: Boolean;
   VBVMWasClosed: TTime;
   SaveMaximized: Boolean = True;
   FlushWaitTime: Integer = 500;
   msgBoxCaption: WideString = 'Warning';
   BackupOldEntries: Boolean = True;
   DontWarn: Boolean = False;
   DefaultVMType: Byte = 0;
   ShowVBCPUVirtualizationOption: Boolean = False;

implementation

uses AddEdit, Progress, Options, InfoMess;

{$R *.dfm}

procedure TfrmMain.OpenInternetHelp(const OwnerWindowHandle: THandle; const SiteHelp: array of WideString);
const
   INTERNET_CONNECTION_MODEM = 1;
   INTERNET_CONNECTION_LAN = 2;
   INTERNET_CONNECTION_PROXY = 4;
   INTERNET_CONNECTION_MODEM_BUSY = 8;
var
   i, dwConnectionTypes: Integer;
   isConnected: Boolean;
   NetHandle: HINTERNET;
   UrlHandle: HINTERNET;
   Buffer: array[0..1024] of Char;
   BytesRead: dWord;
begin
   try
      dwConnectionTypes := INTERNET_CONNECTION_MODEM +
         INTERNET_CONNECTION_LAN +
         INTERNET_CONNECTION_PROXY;
      if InternetGetConnectedState(@dwConnectionTypes, 0) then
         isConnected := True
      else
         isConnected := False;
   except
      isConnected := False;
   end;
   if not isConnected then
   begin
      msgBoxCaption := 'Warning';
      PostMessage(OwnerWindowHandle, WM_USER + 1024, 0, 0);
      MessageBox(OwnerWindowHandle, 'No internet connection detected!', 'Warning', MB_OK or MB_ICONWARNING);
   end
   else
   begin
      for i := Low(SiteHelp) to High(SiteHelp) do
      begin
         NetHandle := InternetOpen(PAnsiChar(Application.Title), INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
         if not Assigned(NetHandle) then
            Continue;
         try
            UrlHandle := InternetOpenUrlW(NetHandle, PWideChar(SiteHelp[i]), nil, 0, INTERNET_FLAG_RELOAD, 0);
            if not Assigned(UrlHandle) then
               Continue;
            try
               try
                  InternetReadFile(UrlHandle, @Buffer, 1024, BytesRead);
                  if BytesRead <> 1024 then
                     Continue;
               except
                  Continue;
               end;
            finally
               InternetCloseHandle(UrlHandle);
            end;
         finally
            InternetCloseHandle(NetHandle);
         end;
         if ShellExecuteW(OwnerWindowHandle, 'open', PWideChar(SiteHelp[i]), nil, nil, SW_SHOW) > 32 then
            Exit;
      end;
      msgBoxCaption := 'Warning';
      PostMessage(OwnerWindowHandle, WM_USER + 1024, 0, 0);
      MessageBox(OwnerWindowHandle, 'Help site not found or error opening browser!', 'Warning', MB_OK or MB_ICONWARNING);
   end;
end;

procedure TfrmMain.pmChangeMessageBox(var Msg: TMessage);
var
   MBRect: TRect;
   i, x, y, w, h: integer;
   ws: WideString;
   p: PChar;
begin
   GetProcessList;
   i := 0;
   try
      p := MAKEINTRESOURCE(WC_DIALOG);
      ws := WideString('#' + IntToStr(Integer(p)));
   except
      ws := '#32770';
   end;
   while i <= High(ProcessInfo) do
   begin
      if ProcessInfo[i].WClass = ws then
         if ProcessInfo[i].WCaption = msgBoxCaption then
            if GetParent(ProcessInfo[i].Handle) = Handle then
               Break;
      Inc(i);
   end;
   if i <= High(ProcessInfo) then
   begin
      try
         if not GetWindowRect(ProcessInfo[i].Handle, MBRect) then
            Exit;
      except
         Exit;
      end;
      w := MBRect.Right - MBRect.Left;
      h := MBRect.Bottom - MBRect.Top;

      x := Left + ((Width - w) div 2);
      if x < 0 then
         x := 0
      else if x + w > Screen.Width then
         x := Screen.Width - w;

      y := Top + ((Height - h) div 2);
      if y < 0 then
         y := 0
      else if y + h > Screen.Height then
         y := Screen.Height - h;
      try
         SetWindowPos(ProcessInfo[i].Handle, 0, x, y, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE
            or SWP_NOZORDER);
      except
      end;
   end;
end;

procedure Replacebks(var ws: WideString; const len: Integer);
var
   i: Integer;
begin
   i := 1;
   while i <= len do
   begin
      if ws[i] = '/' then
         ws[i] := '\';
      Inc(i);
   end;
end;

function FindDriveWithID(const ID: AnsiString): ShortInt;
var
   i: Integer;
   DriveType: Byte;
   RawMBR: array[0..511] of Byte;
   btsIO: DWORD;
   hDrive: THandle;
begin
   Result := -1;
   for i := 0 to MAX_IDE_DRIVES - 1 do
   begin
      if i = OSDrive then
         Continue;
      try
         hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(i)), GENERIC_READ,
            FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
      except
         hDrive := INVALID_HANDLE_VALUE;
      end;
      if hDrive <> INVALID_HANDLE_VALUE then
      begin
         SetFilePointer(hDrive, 512, nil, FILE_BEGIN); //sector 1 for GPT
         if not ReadFile(hDrive, RawMBR[0], 512, btsIO, nil) then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         if (Char(RawMBR[0]) + Char(RawMBR[1]) +
            Char(RawMBR[2]) + Char(RawMBR[3]) +
            Char(RawMBR[4]) + Char(RawMBR[5]) +
            Char(RawMBR[6]) + Char(RawMBR[7])) =
            'EFI PART' then
            DriveType := 1 //GPT
         else
         begin
            DriveType := 0; //MBR
            SetFilePointer(hDrive, 0, nil, FILE_BEGIN); //sector 0 for MBR
            if not ReadFile(hDrive, RawMBR[0], 512, btsIO, nil) then
            begin
               try
                  CloseHandle(hDrive);
               except
               end;
               Continue;
            end;
         end;
         try
            CloseHandle(hDrive);
         except
         end;
         if DriveType = 0 then
         begin
            if (IntToHex(RawMBR[443], 2) + IntToHex(RawMBR[442], 2) + IntToHex(RawMBR[441], 2) +
               IntToHex(RawMBR[440], 2)) = ID then
            begin
               Result := i;
               Exit;
            end;
         end
         else if ID = (IntToHex(RawMBR[59], 2) +
            IntToHex(RawMBR[58], 2) + IntToHex(RawMBR[57], 2) +
            IntToHex(RawMBR[56], 2) + '-' + IntToHex(RawMBR[61], 2) +
            IntToHex(RawMBR[60], 2) + '-' + IntToHex(RawMBR[63], 2) +
            IntToHex(RawMBR[62], 2) + '-' + IntToHex(RawMBR[64], 2) +
            IntToHex(RawMBR[65], 2) + '-' + IntToHex(RawMBR[66], 2) +
            IntToHex(RawMBR[67], 2) + IntToHex(RawMBR[68], 2) +
            IntToHex(RawMBR[69], 2) + IntToHex(RawMBR[70], 2) +
            IntToHex(RawMBR[71], 2)) then
         begin
            Result := i;
            Exit;
         end;
      end;
   end;
end;

function GetDriveID(const aDrive: ShortInt): AnsiString;
var
   DriveType: Byte;
   RawMBR: array[0..511] of Byte;
   btsIO: DWORD;
   hDrive: THandle;
begin
   Result := '';
   if aDrive < 0 then
      Exit;
   try
      hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDrive)), GENERIC_READ,
         FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
   except
      LastError := GetLastError;
      msgBoxCaption := 'Warning';
      PostMessage(frmAddEdit.Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(frmAddEdit.Handle, PWideChar('Can''t access this storage device !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError)), 'Warning', MB_OK or MB_ICONWARNING);
      hDrive := INVALID_HANDLE_VALUE;
   end;
   if hDrive <> INVALID_HANDLE_VALUE then
   begin
      SetFilePointer(hDrive, 512, nil, FILE_BEGIN); //sector 1 for GPT
      if not ReadFile(hDrive, RawMBR[0], 512, btsIO, nil) then
      begin
         LastError := GetLastError;
         msgBoxCaption := 'Warning';
         PostMessage(frmAddEdit.Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(frmAddEdit.Handle, PWideChar('Can''t read from this storage device !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError)), 'Warning', MB_OK or MB_ICONWARNING);
         try
            CloseHandle(hDrive);
         except
         end;
         Exit;
      end;

      if (Char(RawMBR[0]) + Char(RawMBR[1]) +
         Char(RawMBR[2]) + Char(RawMBR[3]) +
         Char(RawMBR[4]) + Char(RawMBR[5]) +
         Char(RawMBR[6]) + Char(RawMBR[7])) =
         'EFI PART' then
         DriveType := 1 //GPT
      else
      begin
         DriveType := 0; //MBR
         SetFilePointer(hDrive, 0, nil, FILE_BEGIN); //sector 0 for MBR
         if not ReadFile(hDrive, RawMBR[0], 512, btsIO, nil) then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Exit;
         end;
      end;
      try
         CloseHandle(hDrive);
      except
      end;
      if DriveType = 0 then
      begin
         Result := IntToHex(RawMBR[443], 2) + IntToHex(RawMBR[442], 2) + IntToHex(RawMBR[441], 2) +
            IntToHex(RawMBR[440], 2)
      end
      else
         Result := IntToHex(RawMBR[59], 2) +
            IntToHex(RawMBR[58], 2) + IntToHex(RawMBR[57], 2) +
            IntToHex(RawMBR[56], 2) + '-' + IntToHex(RawMBR[61], 2) +
            IntToHex(RawMBR[60], 2) + '-' + IntToHex(RawMBR[63], 2) +
            IntToHex(RawMBR[62], 2) + '-' + IntToHex(RawMBR[64], 2) +
            IntToHex(RawMBR[65], 2) + '-' + IntToHex(RawMBR[66], 2) +
            IntToHex(RawMBR[67], 2) + IntToHex(RawMBR[68], 2) +
            IntToHex(RawMBR[69], 2) + IntToHex(RawMBR[70], 2) +
            IntToHex(RawMBR[71], 2);
   end
   else
   begin
      LastError := GetLastError;
      msgBoxCaption := 'Warning';
      PostMessage(frmAddEdit.Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(frmAddEdit.Handle, PWideChar('Can''t access this storage device !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError)), 'Warning', MB_OK or MB_ICONWARNING);
   end;
end;

function GetDriveSize(const Drive: Byte): Int64;
var
   hDrive: THandle;
   dwBytesReturned: DWORD;
   LengthInformation: TGetLengthInformation;
begin
   try
      hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(Drive)), GENERIC_READ,
         FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
   except
      hDrive := INVALID_HANDLE_VALUE;
   end;
   if hDrive <> INVALID_HANDLE_VALUE then
   begin
      try
         if DeviceIoControl(hDrive, IOCTL_DISK_GET_LENGTH_INFO, nil, 0, @LengthInformation, SizeOf(TGetLengthInformation), dwBytesReturned, nil) then
            Result := LengthInformation.Length
         else
            Result := -1;
      except
         Result := -1;
      end;
      try
         CloseHandle(hDrive);
      except
      end;
   end
   else
      Result := -1;
end;

type
   {$Z4}
   STORAGE_QUERY_TYPE = (
      PropertyStandardQuery = 0,
      PropertyExistsQuery,
      PropertyMaskQuery,
      PropertyQueryMaxDefined
      );
   {$Z1}

   {$Z4}
   STORAGE_PROPERTY_ID = (StorageDeviceProperty = 0, StorageAdapterProperty);
   {$Z1}
type
   STORAGE_BUS_TYPE = (
      BusTypeUnknown = $00,
      BusTypeScsi,
      BusTypeAtapi,
      BusTypeAta,
      BusType1394,
      BusTypeSsa,
      BusTypeFibre,
      BusTypeUsb,
      BusTypeRAID,
      BusTypeiScsi,
      BusTypeSas,
      BusTypeSata,
      BusTypeSd,
      BusTypeMmc,
      BusTypeMax,
      BusTypeMaxReserved = $7F);
   STORAGE_PROPERTY_QUERY = record
      PropertyId: STORAGE_PROPERTY_ID;
      QueryType: STORAGE_QUERY_TYPE;
      AdditionalParameters: array[0..1 - 1] of UCHAR;
   end;
   PSTORAGE_PROPERTY_QUERY = ^STORAGE_PROPERTY_QUERY;
   STORAGE_DEVICE_DESCRIPTOR = record
      Version: Cardinal;
      Size: Cardinal;
      DeviceType: Byte;
      DeviceTypeModifier: Byte;
      RemovableMedia: Byte;
      CommandQueueing: Byte;
      VendorIdOffset: Cardinal;
      ProductIdOffset: Cardinal;
      ProductRevisionOffset: Cardinal;
      SerialNumberOffset: Cardinal;
      BusType: STORAGE_BUS_TYPE;
      RawPropertiesLength: Cardinal;
      RawDeviceProperties: array[0..1 - 1] of Byte;
   end;
   PSTORAGE_DEVICE_DESCRIPTOR = ^STORAGE_DEVICE_DESCRIPTOR;
   {$ALIGN on}

function crt_isspace(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'isspace';

function crt_tolower(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'tolower';

function crt_isprint(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'isprint';

function GetDriveVendorAndProductID(const aDrive: Byte): AnsiString;

   function tolower(ch: AnsiChar): AnsiChar;
   begin
      Result := AnsiChar(Chr(crt_tolower(Ord(ch))));
   end;

   function isspace(ch: AnsiChar): Boolean;
   begin
      Result := crt_isspace(Ord(ch)) <> 0;
   end;

   function isprint(ch: AnsiChar): Boolean;
   begin
      Result := crt_isprint(Ord(ch)) <> 0;
   end;

   function flipAndCodeBytes(str: PAnsiChar; pos: Integer; flip: Integer; buf: PAnsiChar): string;
   var
      i, j, k: Integer;
      p: Integer;
      c: AnsiChar;
      t: AnsiChar;
   begin
      j := 0;
      k := 0;

      buf[0] := Chr(0);
      if (pos <= 0) then
      begin
         Result := buf;
         exit;
      end;

      if (j = 0) then
      begin
         p := 0;

         j := 1;
         k := 0;
         buf[k] := Chr(0);
         i := pos;
         while (j <> 0) and (str[i] <> Chr(0)) do
         begin
            c := tolower(str[i]);

            if (isspace(c)) then
               c := Chr(0);

            inc(p);
            buf[k] := AnsiChar(Chr(Ord(buf[k]) shl 4));

            if ((c >= '0') and (c <= '9')) then
               buf[k] := AnsiChar(Chr(Ord(buf[k]) or Byte(Ord(c) - Ord('0'))))
            else if ((c >= 'a') and (c <= 'f')) then
               buf[k] := AnsiChar(Chr(Ord(buf[k]) or Byte(Ord(c) - Ord('a') + 10)))
            else
            begin
               j := 0;
               break;
            end;

            if (p = 2) then
            begin
               if ((buf[k] <> Chr(0)) and (not isprint(buf[k]))) then
               begin
                  j := 0;
                  break;
               end;
               inc(k);
               p := 0;
               buf[k] := Chr(0);
            end;
            inc(i);
         end;
      end;

      if (j = 0) then
      begin
         j := 1;
         k := 0;
         i := pos;
         while ((j <> 0) and (str[i] <> Chr(0))) do
         begin
            c := str[i];

            if (not isprint(c)) then
            begin
               j := 0;
               break;
            end;

            buf[(k)] := c;
            inc(k);
            inc(i);
         end;
      end;

      if (j = 0) then
         k := 0;

      buf[k] := Chr(0);

      if (flip <> 0) then
      begin
         j := 0;
         while (j < k) do
         begin
            t := buf[j];
            buf[j] := buf[j + 1];
            buf[j + 1] := t;
            j := j + 2;
         end
      end;

      i := -1;
      j := -1;
      k := 0;
      while (buf[k] <> Chr(0)) do
      begin
         if (not isspace(buf[k])) then
         begin
            if (i < 0) then
               i := k;
            j := k;
         end;
         inc(k);
      end;

      if ((i >= 0) and (j >= 0)) then
      begin
         k := i;
         while ((k <= j) and (buf[k] <> Chr(0))) do
         begin
            buf[k - i] := buf[k];
            inc(k);
         end;
         buf[k - i] := Chr(0);
      end;

      Result := buf;
   end;

var
   hDrive: THandle;
   query: STORAGE_PROPERTY_QUERY;
   cbBytesReturned: Cardinal;
   buffer: array[0..10000 - 1] of AnsiChar;
   descrip: PSTORAGE_DEVICE_DESCRIPTOR;
   vendorId: array[0..10000 - 1] of AnsiChar;
   modelNumber: array[0..10000 - 1] of AnsiChar;
begin
   try
      hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDrive)), 0,
         FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
   except
      hDrive := INVALID_HANDLE_VALUE;
   end;
   if hDrive <> INVALID_HANDLE_VALUE then
   begin
      cbBytesReturned := 0;
      FillMemory(@query, sizeof(query), 0);
      query.PropertyId := StorageDeviceProperty;
      query.QueryType := PropertyStandardQuery;
      FillMemory(@buffer, sizeof(buffer), 0);
      try
         if DeviceIoControl(hDrive, IOCTL_STORAGE_QUERY_PROPERTY, @query, sizeof(query),
            @buffer, sizeof(buffer), cbBytesReturned, nil) then
         begin
            descrip := PSTORAGE_DEVICE_DESCRIPTOR(@buffer);
            flipAndCodeBytes(buffer, descrip^.VendorIdOffset, 0, vendorId);
            flipAndCodeBytes(buffer, descrip^.ProductIdOffset, 0, modelNumber);
            Result := AnsiString(vendorId) + ' ' + AnsiString(modelNumber);
         end;
      except
         Result := 'Unknown name';
      end;
      try
         CloseHandle(hDrive);
      except
      end;
   end
   else
      Result := 'Unknown name';
end;

procedure FlushToDisk(const hVolume: THandle);
begin
   try
      FlushFileBuffers(hVolume);
   except
   end;
end;

function TfrmMain.LockVolume(const vi: VolumeInfo): Boolean;
const
   FSCTL_LOCK_VOLUME = (9 shl 16) or (0 shl 14) or (6 shl 2) or 0;
var
   dwBytesReturned: Cardinal;
   i: Integer;
begin
   try
      Result := DeviceIoControl(vi.Handle, FSCTL_LOCK_VOLUME, nil, 0,
         nil, 0, dwBytesReturned, nil);
      LastError := GetLastError;
   except
      Result := False;
   end;
   if Result then
      Exit
   else
      LastError := GetLastError;
   ShowingProgress := False;
   ProgressCancelled := False;
   try
      if frmProgress = nil then
         Application.CreateForm(TfrmProgress, frmProgress);
      with frmProgress do
      begin
         lblMessage.Caption := 'Trying to lock volume ''' + vi.Letter + ''' on "' + vi.DriveProp + '"...';
         btnCancel.Caption := 'Cancel (unsafe)';
         pbProgress.Max := 100;
         Show;
      end;
      Application.ProcessMessages;
      ShowingProgress := True;
   except
      if frmProgress.Visible then
         frmProgress.Close;
      frmProgress.Free;
      frmProgress := nil;
   end;
   for i := 1 to 100 do
   begin
      Sleep(100);
      if ShowingProgress then
      begin
         frmProgress.pbProgress.Position := i;
         Application.ProcessMessages;
         if not frmProgress.Visible then
         begin
            Sleep(100);
            Break;
         end;
      end;
      if i mod 5 = 1 then
      begin
         try
            Result := DeviceIoControl(vi.Handle, FSCTL_LOCK_VOLUME, nil, 0,
               nil, 0, dwBytesReturned, nil);
            LastError := GetLastError;
         except
            Result := False;
         end;
         if Result then
            Break;
      end;
   end;
   if ShowingProgress then
      try
         if frmProgress.Visible then
            frmProgress.Close;
         frmProgress.Free;
         frmProgress := nil;
      except
      end;
end;

function DismountVolume(const hVolume: THandle): Boolean;
const
   FSCTL_DISMOUNT_VOLUME = (9 shl 16) or (0 shl 14) or (8 shl 2) or 0;
var
   dwBytesReturned: Cardinal;
begin
   try
      Result := DeviceIoControl(hVolume, FSCTL_DISMOUNT_VOLUME, nil, 0,
         nil, 0, dwBytesReturned, nil);
   except
      Result := False;
   end;
   if not Result then
      LastError := GetLastError;
end;

procedure UpdateDrive(const aDrive: Byte);
var
   hDrive: THandle;
   dwBytesReturned: Cardinal;
begin
   hDrive := INVALID_HANDLE_VALUE;
   try
      hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDrive)), GENERIC_READ or GENERIC_WRITE,
         FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
   except
   end;
   if hDrive <> INVALID_HANDLE_VALUE then
   begin
      try
         DeviceIoControl(hDrive, IOCTL_DISK_UPDATE_PROPERTIES, nil, 0, nil, 0, dwBytesReturned, nil);
      except
      end;
      try
         CloseHandle(hDrive);
      except
      end;
   end;
end;

function GetEnvVarValue(const VarName: WideString): WideString;
var
   BufSize: Integer;
begin
   BufSize := GetEnvironmentVariableW(
      PWideChar(VarName), nil, 0);
   if BufSize > 0 then
   begin
      SetLength(Result, BufSize - 1);
      GetEnvironmentVariableW(PWideChar(VarName),
         PWideChar(Result), BufSize);
   end
   else
      Result := '';
end;

function GenGuid: AnsiString;
var
   g: TGUID;
   r: Boolean;
begin
   try
      r := CreateGUID(g) = S_OK;
   except
      r := False;
   end;
   if r then
   begin
      try
         Result := GUIDToString(g);
         Result := AnsiLowerCase(Copy(Result, 2, Length(Result) - 2));
      except
         Result := '';
      end;
   end
   else
      Result := '';
   if Result = '' then
   begin
      if not Randomized then
      begin
         Randomize;
         Randomized := True;
      end;
      Result := AnsiLowerCase(IntToHex(Random(16777216), 6) + IntToHex(Random(256), 2) + '-' +
         IntToHex(Random(65536), 4) + '-' + IntToHex(Random(65536), 4) + '-' + IntToHex(Random(65536), 4) + '-' +
         IntToHex(Random(16777216), 6) + IntToHex(Random(16777216), 6));
   end;
end;

function GenID: AnsiString;
var
   g: TGUID;
   r: Boolean;
begin
   try
      r := CreateGUID(g) = S_OK;
   except
      r := False;
   end;
   if r then
   begin
      try
         Result := GUIDToString(g);
         Result := AnsiLowerCase(Result[2] + Result[6] + Result[11] + Result[14] + Result[18] + Result[22] + Result[28] + Result[34])
      except
         Result := '';
      end;
   end
   else
      Result := '';
   if Result = '' then
   begin
      if not Randomized then
      begin
         Randomize;
         Randomized := True;
      end;
      Result := AnsiLowerCase(IntToHex(Random(16777216), 6) + IntToHex(Random(256), 2));
   end;
end;

procedure TfrmMain.LoadVMentries(const FileName: WideString);
var
   i, j, l, p, c: Integer;
   t: TTNTFileStream;
   st: WideString;
   wsa: array of WideString;
begin
   try
      t := TTNTFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         MessageBoxW(Handle, PWideChar('Could not open "' + FileName + '" for reading !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         Exit;
      end;
   end;
   l := 0;
   try
      l := Min(1048576, t.Size div 2);
      SetLength(psEntries, l);
      t.Position := 0;
      t.ReadBuffer(Pointer(psEntries)^, l * 2);
   except
      on E: Exception do
         MessageBoxW(Handle, PWideChar('Could not read from "' + FileName + '" !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
   end;
   try
      t.Free;
   except
   end;

   if psEntries = '' then
      Exit;
   try
      SetLength(wsa, 0);
      p := 2;
      i := PosEx(#13, psEntries, 2);
      while i > 0 do
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psEntries, p, i - p));
         p := i + 1;
         if i < l then
            if psEntries[i + 1] = #10 then
               Inc(p);
         i := PosEx(#13, psEntries, p);
      end;
      if p <= l then
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psEntries, p, l - p + 1));
      end;
   except
   end;

   c := -1;
   for i := 0 to High(wsa) do
   begin
      l := Length(wsa[i]);
      if l < 3 then
         Continue;
      if (wsa[i][1] = '[') and (wsa[i][l] = ']') then
      begin
         st := Trim(Copy(wsa[i], 2, Min(1024, l - 2)));
         if st <> '' then
         begin
            Inc(c);
            SetLength(VMEntries, c + 1);
            with VMEntries[c] do
            begin
               Name := st;
               ModeLoadVM := 2;
               Priority := 1;
               FirstDriveName := 'Unknown';
               VBCPUVirtualization := 0;
               CDROMType := 0;
               Memory := 512;
               Audio := 0;
            end;
         end;
      end;
      if c > -1 then
         with VMEntries[c] do
         begin
            if (Pos('Type=', wsa[i]) = 1) and (l > 5) then
            begin
               st := Trim(Copy(wsa[i], 6, Min(100, l - 5)));
               if st = 'VirtualBox' then
               begin
                  Ptype := 0;
                  ModeLoadVM := 0;
               end
               else if st = 'Qemu' then
                  Ptype := 1
               else
               begin
                  Ptype := 0;
                  ModeLoadVM := 0;
               end;
            end;
            if Ptype <> 1 then
               if (Pos('ModeToLoadVM=', wsa[i]) = 1) and (l > 13) then
               begin
                  st := Trim(Copy(wsa[i], 14, Min(1024, l - 13)));
                  if st = 'VMName' then
                     ModeLoadVM := 0
                  else if st = 'PathToVM' then
                     ModeLoadVM := 1
                  else if st = 'ExeParameters' then
                     ModeLoadVM := 2
                  else if Ptype = 1 then
                     ModeLoadVM := 2
                  else
                     ModeLoadVM := 0;
               end;
            if (Pos('ExeParams=', wsa[i]) = 1) and (l > 10) then
               ExeParams := Trim(Copy(wsa[i], 11, Min(10240, l - 10)));
            if Ptype <> 1 then
            begin
               if (Pos('VMID=', wsa[i]) = 1) and (l > 5) then
                  VMID := Trim(Copy(wsa[i], 6, Min(1024, l - 5)));
               if (Pos('PathToVM=', wsa[i]) = 1) and (l > 9) then
                  VMPath := Trim(Copy(wsa[i], 10, Min(1024, l - 9)));
            end;
            if (Pos('VMName=', wsa[i]) = 1) and (l > 7) then
               VMName := Trim(Copy(wsa[i], 8, l - 7));
            if (Pos('FirstDriveID=', wsa[i]) = 1) and (l > 13) then
               FirstDriveID := Trim(Copy(wsa[i], 14, Min(1024, l - 13)));
            if (Pos('FirstDriveName=', wsa[i]) = 1) and (l > 15) then
               FirstDriveName := Trim(Copy(wsa[i], 16, Min(1024, l - 15)));
            if (Pos('SecondDriveID=', wsa[i]) = 1) and (l > 14) then
            begin
               SecondDriveID := Trim(Copy(wsa[i], 15, Min(1024, l - 14)));
               if SecondDriveID <> '' then
                  if SecondDriveName = '' then
                     SecondDriveName := 'Unknown';
            end;
            if (Pos('SecondDriveName=', wsa[i]) = 1) and (l > 16) then
               SecondDriveName := Trim(Copy(wsa[i], 17, Min(1024, l - 16)));
            if (Pos('EnableCPUVirtualization=', wsa[i]) = 1) and (l > 24) then
            begin
               st := Trim(Copy(wsa[i], 25, Min(1024, l - 24)));
               if st = 'Unchanged' then
                  VBCPUVirtualization := 0
               else if st = 'On' then
                  VBCPUVirtualization := 1
               else if st = 'Off' then
                  VBCPUVirtualization := 2
               else if st = 'Switch' then
                  VBCPUVirtualization := 3
               else
                  VBCPUVirtualization := 0;
            end;
            if (Pos('InternalHDD=', wsa[i]) = 1) and (l > 12) then
               InternalHDD := Trim(Copy(wsa[i], 13, Min(1024, l - 12)));
            if (Pos('CDDVDName=', wsa[i]) = 1) and (l > 10) then
               CDROMName := Trim(Copy(wsa[i], 11, Min(1024, l - 10)));
            if (Pos('CDDVDType=', wsa[i]) = 1) and (l > 10) then
               if Trim(Copy(wsa[i], 11, Min(100, l - 10))) = 'File' then
                  CDROMType := 1;

            if (Pos('Memory=', wsa[i]) = 1) and (l > 7) then
               Memory := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 8, Min(5, l - 7))), 512), 1), 65535);
            if (Pos('Audio=', wsa[i]) = 1) and (l > 6) then
            begin
               st := Trim(Copy(wsa[i], 7, Min(1024, l - 6)));
               if st = 'Creative Sound Blaster 16' then
                  Audio := 1
               else if st = 'PC speaker' then
                  Audio := 2
               else if st = 'Intel HD Audio' then
                  Audio := 3
               else if st = 'Gravis Ultrasound GF1' then
                  Audio := 4
               else if st = 'ENSONIQ AudioPCI ES1370' then
                  Audio := 5
               else if st = 'CS4231A' then
                  Audio := 6
               else if st = 'Yamaha YM3812 (OPL2)' then
                  Audio := 7
               else if st = 'Intel 82801AA AC97 Audio' then
                  Audio := 8
               else
                  Audio := 0;
            end;
            if (Pos('Run=', wsa[i]) = 1) and (l > 4) then
            begin
               st := Trim(Copy(wsa[i], 5, Min(1024, l - 4)));
               if st = 'Normal' then
                  Run := 0
               else if st = 'Minimized' then
                  Run := 1
               else if st = 'Maximized' then
                  Run := 2
               else if ((Ptype = 0) and (st = 'Maximized')) or ((Ptype = 1) and (st = 'Hidden')) then
                  Run := 3
               else
                  Run := 0;
            end;
            if (Pos('Priority=', wsa[i]) = 1) and (l > 9) then
            begin
               st := Trim(Copy(wsa[i], 10, Min(1024, l - 9)));
               if st = 'BelowNormal' then
                  Priority := 0
               else if st = 'Normal' then
                  Priority := 1
               else if st = 'AboveNormal' then
                  Priority := 2
               else if st = 'High' then
                  Priority := 3
               else
                  Priority := 1;
            end;
         end;
   end;
   for i := 0 to High(VMEntries) do
      if VMEntries[i].Ptype = 1 then
         try
            st := VMEntries[i].ExeParams;
            p := Pos('-m ', st);
            if (p = 1) or ((p > 1) and (st[p - 1] = ' ')) then
            begin
               j := p + 3;
               l := Length(st);
               while j <= l do
               begin
                  if (st[j] < '0') or (st[j] > '9') then
                     Break;
                  Inc(j);
               end;
               Delete(st, Max(1, p - 1), j - Max(1, p - 1));
            end;
            p := Pos('-soundhw ', st);
            if (p = 1) or ((p > 1) and (st[p - 1] = ' ')) then
            begin
               j := p + 9;
               l := Length(st);
               while j <= l do
               begin
                  if (st[j] = '-') or (st[j] = ' ') then
                     Break;
                  Inc(j);
               end;
               Delete(st, Max(1, p - 1), j - Max(1, p - 1));
            end;
            VMEntries[i].ExeParams := st;
         except
         end;
end;

procedure TfrmMain.SaveVMentries(const FileName: WideString);
var
   i, l: Integer;
   t: TTNTFileStream;
   s, sType, sMode, sRun, sPriority, sEnableCPUVirtualization, BaseFolder, sAudio, sCDROMType: WideString;
begin
   s := #65279;
   for i := 0 to High(VMentries) do
      with VMentries[i] do
      begin
         if Ptype = 0 then
            sType := 'VirtualBox'
         else
            sType := 'Qemu';
         case ModeLoadVM of
            1: sMode := 'PathToVM';
            2: sMode := 'ExeParameters';
         else
            sMode := 'VMName';
         end;
         case VBCPUVirtualization of
            1: sEnableCPUVirtualization := 'On';
            2: sEnableCPUVirtualization := 'Off';
            3: sEnableCPUVirtualization := 'Switch';
         else
            sEnableCPUVirtualization := 'Unchanged';
         end;
         if CDROMType = 0 then
            sCDROMType := 'Device'
         else
            sCDROMType := 'File';
         case Audio of
            1: sAudio := 'Creative Sound Blaster 16';
            2: sAudio := 'PC speaker';
            3: sAudio := 'Intel HD Audio';
            4: sAudio := 'Gravis Ultrasound GF1';
            5: sAudio := 'ENSONIQ AudioPCI ES1370';
            6: sAudio := 'CS4231A';
            7: sAudio := 'Yamaha YM3812 (OPL2)';
            8: sAudio := 'Intel 82801AA AC97 Audio';
         else
            sAudio := 'None';
         end;
         case Run of
            1: sRun := 'Minimized';
            2: sRun := 'Maximized';
            3: if Ptype = 0 then
                  sRun := 'Fullscreen'
               else
                  sRun := 'Hidden';
         else
            sRun := 'Normal';
         end;
         case Priority of
            0: sPriority := 'BelowNormal';
            2: sPriority := 'AboveNormal';
            3: sPriority := 'High';
         else
            sPriority := 'Normal';
         end;
         if AddSecondDrive then
         begin
            if Ptype = 0 then
            begin
               if ShowVBCPUVirtualizationOption then
                  s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveID=' + SecondDriveID + #13#10'SecondDriveName=' + SecondDriveName + #13#10'EnableCPUVirtualization=' + sEnableCPUVirtualization + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10
               else
                  s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveID=' + SecondDriveID + #13#10'SecondDriveName=' + SecondDriveName + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
            end
            else
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ExeParams=' + ExeParams + #13#10'VMName=' + VMName + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveID=' + SecondDriveID + #13#10'SecondDriveName=' + SecondDriveName + #13#10'InternalHDD=' + InternalHDD + #13#10'CDDVDName=' + CDROMName + #13#10'CDDVDType=' + sCDROMType + #13#10'Memory=' + IntToStr(Memory) + #13#10'Audio=' + sAudio + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
         end
         else if Ptype = 0 then
         begin
            if ShowVBCPUVirtualizationOption then
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'EnableCPUVirtualization=' + sEnableCPUVirtualization + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10
            else
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
         end
         else
            s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ExeParams=' + ExeParams + #13#10'VMName=' + VMName + #13#10'FirstDriveID=' + FirstDriveID + #13#10'FirstDriveName=' + FirstDriveName + #13#10'InternalHDD=' + InternalHDD + #13#10'CDDVDName=' + CDROMName + #13#10'CDDVDType=' + sCDROMType + #13#10'Memory=' + IntToStr(Memory) + #13#10'Audio=' + sAudio + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
      end;
   if psEntries = s then
      Exit;
   if BackupOldEntries then
      try
         if WideFileExists(FileName + '.bak') then
            WideDeleteFile(FileName + '.bak');
         if WideFileExists(FileName) then
            WideRenameFile(FileName, FileName + '.bak');
      except
      end;
   if isInstalledVersion then
   begin
      try
         BaseFolder := WideExtractFilePath(FileName);
         if not WideDirectoryExists(BaseFolder) then
            WideForceDirectories(BaseFolder);
      except
      end;
      if not WideDirectoryExists(BaseFolder) then
      begin
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not create "' + BaseFolder + '" !'), 'Error', MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      t := TTNTFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not create or open "' + FileName + '" for writing !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      l := Length(s);
      t.Size := 2 * l;
      t.Position := 0;
      t.WriteBuffer(Pointer(s)^, 2 * l);
      psEntries := s;
   except
      on E: Exception do
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not write into "' + FileName + '" !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         end;
   end;
   try
      t.Free;
   except
   end;
end;

function TfrmMain.LoadCFG(const FileName: WideString): Boolean;
var
   i, j, l, p: Integer;
   t: TTNTFileStream;
   ws, wst: WideString;
   wsa: array of WideString;
begin
   Result := False;
   try
      t := TTNTFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         MessageBoxW(Handle, PWideChar('Could not open "' + FileName + '" for reading !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         Exit;
      end;
   end;
   l := 0;
   try
      l := Min(1048576, t.Size div 2);
      SetLength(psCFG, l);
      t.Position := 0;
      t.ReadBuffer(Pointer(psCFG)^, l * 2);
   except
      on E: Exception do
         MessageBoxW(Handle, PWideChar('Could not read from "' + FileName + '" !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
   end;
   try
      t.Free;
   except
   end;

   if psCFG = '' then
      Exit;
   try
      SetLength(wsa, 0);
      p := 2;
      i := PosEx(#13, psCFG, 2);
      while i > 0 do
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psCFG, p, i - p));
         p := i + 1;
         if i < l then
            if psCFG[i + 1] = #10 then
               Inc(p);
         i := PosEx(#13, psCFG, p);
      end;
      if p <= l then
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psCFG, p, l - p + 1));
      end;
   except
   end;

   Result := Length(wsa) > 0;

   for i := 0 to High(wsa) do
   begin
      l := Length(wsa[i]);
      if l < 3 then
         Continue;
      if (Pos('DriveMessageShowed=', wsa[i]) = 1) and (l > 19) then
         DriveMessageShowed := StrToBoolDef(Trim(Copy(wsa[i], 20, Min(100, l - 19))), DriveMessageShowed);
      if (Pos('StartMessageShowed=', wsa[i]) = 1) and (l > 14) then
         StartMessageShowed := StrToBoolDef(Trim(Copy(wsa[i], 20, Min(100, l - 19))), StartMessageShowed);
      if (Pos('Width=', wsa[i]) = 1) and (l > 6) then
         MainWidth := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 7, Min(100, l - 6))), MainWidth), frmMain.Constraints.MinWidth), Screen.WorkAreaWidth);
      if (Pos('Height=', wsa[i]) = 1) and (l > 7) then
         MainHeight := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 8, Min(100, l - 7))), MainHeight), frmMain.Constraints.MinHeight), Screen.WorkAreaHeight);
      if (Pos('Left=', wsa[i]) = 1) and (l > 5) then
         MainLeft := Min(Max(Round(0.0001 * Screen.WorkAreaWidth * StrToIntDef(Trim(Copy(wsa[i], 6, Min(100, l - 5))), Round(10000.0 * (MainLeft - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + Screen.WorkAreaLeft), Screen.WorkAreaLeft), Screen.WorkAreaWidth - MainWidth);
      if (Pos('Top=', wsa[i]) = 1) and (l > 4) then
         MainTop := Min(Max(Round(0.0001 * Screen.WorkAreaHeight * StrToIntDef(Trim(Copy(wsa[i], 5, Min(100, l - 4))), Round(10000.0 * (MainTop - Screen.WorkAreaTop) / Screen.WorkAreaHeight)) + Screen.WorkAreaTop), Screen.WorkAreaTop), Screen.WorkAreaHeight - MainHeight);
      if (Pos('Maximized=', wsa[i]) = 1) and (l > 10) then
         MainMaximized := StrToBoolDef(Trim(Copy(wsa[i], 11, l - 10)), MainMaximized);
      for j := 0 to pmHeaders.Items.Count - 1 do
      begin
         ws := AnsiReplaceStr(pmHeaders.Items[j].Caption, ' ', '') + 'ColumnWidth=';
         if (Pos(ws, wsa[i]) = 1) and (l > Length(ws)) then
            pmHeaders.Items[j].Tag := Min(Max(StrToIntDef(Trim(Copy(wsa[i], Length(ws) + 1, Min(100, l - Length(ws)))), pmHeaders.Items[j].Tag), 10), MainWidth);
         ws := AnsiReplaceStr(pmHeaders.Items[j].Caption, ' ', '') + 'ColumnShow=';
         if (Pos(ws, wsa[i]) = 1) and (l > Length(ws)) then
            pmHeaders.Items[j].Checked := StrToBoolDef(Trim(Copy(wsa[i], Length(ws) + 1, Min(100, l - Length(ws)))), pmHeaders.Items[j].Checked);
      end;
      if (Pos('WaitTimeToFlush=', wsa[i]) = 1) and (l > 16) then
         FlushWaitTime := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 17, Min(100, l - 16))), 500), 0), 20000);
      if (Pos('LockTheVolumes=', wsa[i]) = 1) and (l > 15) then
         LockVolumes := StrToBoolDef(Trim(Copy(wsa[i], 16, Min(100, l - 15))), LockVolumes);
      if (Pos('ShowSecondDriveOption=', wsa[i]) = 1) and (l > 22) then
         AddSecondDrive := StrToBoolDef(Trim(Copy(wsa[i], 23, Min(100, l - 22))), AddSecondDrive);
      if (Pos('BackupOldEntries=', wsa[i]) = 1) and (l > 17) then
         BackupOldEntries := StrToBoolDef(Trim(Copy(wsa[i], 18, Min(100, l - 17))), BackupOldEntries);
      if (Pos('DontWarn=', wsa[i]) = 1) and (l > 9) then
         DontWarn := StrToBoolDef(Trim(Copy(wsa[i], 10, Min(100, l - 9))), DontWarn);
      if (Pos('DefaultVMType=', wsa[i]) = 1) and (l > 14) then
         if Trim(Copy(wsa[i], 15, Min(100, l - 14))) = 'QEMU' then
            DefaultVMType := 1;
      if (Pos('VirtualBoxPath=', wsa[i]) = 1) and (l > 15) then
      begin
         wst := Trim(Copy(wsa[i], 16, Min(2048, l - 15)));
         if Length(wst) <= 512 then
            ExeVBPath := wst
         else
            ExeVBPath := Copy(wst, 1, 512);
      end;
      if (Pos('MethodToUpdateTheVM=', wsa[i]) = 1) and (l > 20) then
      begin
         wst := Trim(Copy(wsa[i], 21, Min(1024, l - 20)));
         if wst = 'use VBoxManage.exe command line (slower)' then
            UpdateVM := 0
         else if wst = 'directly (faster, but VB Manager must be closed)' then
            UpdateVM := 1
         else
            UpdateVM := 0;
      end;
      if (Pos('ShowCPUVirtualizationOption=', wsa[i]) = 1) and (l > 28) then
         ShowVBCPUVirtualizationOption := StrToBoolDef(Trim(Copy(wsa[i], 29, Min(100, l - 28))), ShowVBCPUVirtualizationOption);
      if (Pos('QemuPath=', wsa[i]) = 1) and (l > 9) then
      begin
         wst := Trim(Copy(wsa[i], 10, Min(2048, l - 9)));
         if Length(wst) <= 512 then
            ExeQPath := wst
         else
            ExeQPath := Copy(wst, 1, 512);
      end;
      if (Pos('QemuDefaultParameters=', wsa[i]) = 1) and (l > 22) then
      begin
         wst := Trim(Copy(wsa[i], 23, Min(20480, l - 22)));
         if Length(wst) <= 10240 then
            QEMUDefaultParameters := wst
         else
            QEMUDefaultParameters := Copy(wst, 1, 10240);
      end;
      if (Pos('LastSelected=', wsa[i]) = 1) and (l > 13) then
         LastSelected := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 14, Min(10, l - 13))), 0), -1), lvVMs.Items.Count - 1);
   end;
end;

procedure TfrmMain.SaveCFG(const FileName: WideString);
var
   i, l: Integer;
   t: TTNTFileStream;
   ws, wsVMUpdate: WideString;
   BaseFolder: WideString;
   h: array of Integer;
   s, sDefaultVMType: AnsiString;
begin
   ws := #65279;
   if WindowState <> wsNormal then
      ws := ws + 'Width=' + IntToStr(IntWidth) + #13#10'Height=' + IntToStr(IntHeight) + #13#10'Left=' + IntToStr(Round(10000.0 * (IntLeft - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + #13#10'Top=' + IntToStr(Round(10000.0 * (IntTop - Screen.WorkAreaTop) / Screen.WorkAreaHeight))
   else
      ws := ws + 'Width=' + IntToStr(Width) + #13#10'Height=' + IntToStr(Height) + #13#10'Left=' + IntToStr(Round(10000.0 * (Left - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + #13#10'Top=' + IntToStr(Round(10000.0 * (Top - Screen.WorkAreaTop) / Screen.WorkAreaHeight));
   ws := ws + #13#10'Maximized=' + IntToStr(Integer((WindowState = wsMaximized) and SaveMaximized));
   SetLength(h, pmHeaders.Items.Count);
   for i := 0 to pmHeaders.Items.Count - 1 do
      h[i] := pmHeaders.Items[i].Tag;
   for i := 1 to lvVMs.Columns.Count - 1 do
      try
         h[lvVMs.Columns[i].Tag] := lvVMs.Columns[i].Width;
      except
      end;
   s := pmHeaders.Items[3].Caption;
   pmHeaders.Items[3].Caption := 'Drive';
   for i := 0 to pmHeaders.Items.Count - 1 do
      ws := ws + #13#10 + AnsiReplaceStr(pmHeaders.Items[i].Caption, ' ', '') + 'ColumnWidth=' + IntToStr(h[i]) + #13#10 + AnsiReplaceStr(pmHeaders.Items[i].Caption, ' ', '') + 'ColumnShow=' + IntToStr(Integer(pmHeaders.Items[i].Checked));
   pmHeaders.Items[3].Caption := s;
   if UpdateVM = 0 then
      wsVMUpdate := 'use VBoxManage.exe command line (slower)'
   else
      wsVMUpdate := 'directly (faster, but VB Manager must be closed)';
   if DefaultVMType = 0 then
      sDefaultVMType := 'VirtualBox'
   else
      sDefaultVMType := 'QEMU';
   ws := ws + #13#10'WaitTimeToFlush=' + IntToStr(FlushWaitTime) + #13#10'LockTheVolumes=' + IntToStr(Integer(LockVolumes)) + #13#10'ShowSecondDriveOption=' + IntToStr(Integer(AddSecondDrive)) + #13#10'BackupOldEntries=' + IntToStr(Integer(BackupOldEntries)) + #13#10'DontWarn=' + IntToStr(Integer(DontWarn)) + #13#10'DefaultVMType=' + sDefaultVMType + #13#10'VirtualBoxPath=' + ExeVBPath + #13#10'MethodToUpdateTheVM=' + wsVMUpdate + #13#10'ShowCPUVirtualizationOption=' + IntToStr(Integer(ShowVBCPUVirtualizationOption)) + #13#10'QemuPath=' + ExeQPath + #13#10'QemuDefaultParameters=' + QemuDefaultParameters + #13#10'LastSelected=' + IntToStr(lvVMs.ItemIndex) + #13#10'DriveMessageShowed=' + IntToStr(Integer(DriveMessageShowed)) + #13#10'StartMessageShowed=' + IntToStr(Integer(StartMessageShowed));
   if isInstalledVersion then
   begin
      try
         BaseFolder := WideExtractFilePath(FileName);
         if not WideDirectoryExists(BaseFolder) then
            WideForceDirectories(BaseFolder);
      except
      end;
      if not WideDirectoryExists(BaseFolder) then
      begin
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not create "' + BaseFolder + '" !'), 'Error', MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   if ws = psCFG then
      Exit;
   try
      t := TTNTFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not create or open "' + FileName + '" for writing !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      l := Length(ws);
      t.Size := 2 * l;
      t.Position := 0;
      t.WriteBuffer(Pointer(ws)^, 2 * l);
      psCFG := ws;
   except
      on E: Exception do
         if not DontWarn then
         begin
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle, PWideChar('Could not write into "' + FileName + '" !'#13#10#13#10'System message: ' + E.Message), 'Error', MB_OK or MB_ICONERROR);
         end;
   end;
   try
      t.Free;
   except
   end;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
   Close;
   btnExit.Down := False;
end;

procedure TfrmMain.btnAddClick(Sender: TObject);
var
   i, p, cp, l, n1, n2, n3, a: Integer;
   s: AnsiString;
   ws, wst, FolderName: WideString;
begin
   btnAdd.Down := True;
   try
      try
         with frmAddEdit do
         begin
            if frmAddEdit = nil then
               Application.CreateForm(TfrmAddEdit, frmAddEdit)
            else
            begin
               cmbMode.ItemIndex := 0;
               if rbVirtualBox.Checked then
                  cmbModeChange(cmbMode)
               else
                  rbVirtualBox.Checked := True;
               edtExeParams.Text := '';
               cmbVMName.ItemIndex := 0;
               edtVMPath.Text := '';
               cmbFirstDrive.ItemIndex := 0;
               cmbSecondDrive.ItemIndex := 0;
               cmbEnableCPUVirtualization.ItemIndex := 0;
               edtHDD.Text := '';
               edtMemory.Text := '512';
               cmbAudio.ItemIndex := 1;
               cmbWS.ItemIndex := 0;
               cmbPriority.ItemIndex := 1;
            end;
            Caption := 'Add';
            isEdit := False;
            edtName.Text := 'USB Boot test';
            if DefaultVMType = 1 then
               rbQEMU.Checked := True;
            if ShowModal = mrOK then
            begin
               SetLength(VMentries, Length(VMentries) + 1);
               with VMentries[High(VMentries)] do
               begin
                  Name := Trim(edtName.Text);
                  Ptype := Byte(not rbVirtualBox.Checked);
                  if rbVirtualBox.Checked then
                  begin
                     ModeLoadVM := cmbMode.ItemIndex;

                     case ModeLoadVM of
                        0:
                           begin
                              VMName := VMIDs[cmbVMName.ItemIndex - 1].Name;
                              VMID := VMIDs[cmbVMName.ItemIndex - 1].ID;
                              FolderName := '';
                              with frmMain.xmlGen do
                              begin
                                 if Tag = 1 then
                                    try
                                       Active := True;
                                       n1 := ChildNodes.IndexOf('VirtualBox');
                                       if n1 > -1 then
                                       begin
                                          n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                          if n2 > -1 then
                                          begin
                                             n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                             if n3 > -1 then
                                             begin
                                                a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                if a > -1 then
                                                begin
                                                   FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                   l := Length(FolderName);
                                                   Replacebks(FolderName, l);
                                                end;
                                             end;
                                          end;
                                       end;
                                    except
                                    end;
                                 Active := False;
                              end;

                              if WideDirectoryExists(FolderName) then
                                 VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                              else
                                 VMPath := '';
                           end;
                        1:
                           begin
                              VMPath := Trim(edtVMPath.Text);
                              VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                              i := 0;
                              while i <= High(VMIDs) do
                              begin
                                 if VMIDs[i].Name = VMName then
                                    Break;
                                 Inc(i);
                              end;
                              VMID := VMIDs[i].ID;
                           end;
                        2:
                           begin
                              ws := Trim(edtExeParams.Text);
                              p := Pos('--startvm "', ws);
                              l := Length(ws);
                              if (p > 0) and ((p + 11) < l) then
                              begin
                                 cp := PosEx('"', ws, p + 11);
                                 if cp > 0 then
                                    ws := Trim(Copy(ws, p + 11, cp - p - 11))
                                 else
                                    ws := '';
                              end
                              else
                                 ws := '';
                              if WideFileExists(ws) then
                              begin
                                 wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                 GetNamesAndIDs;
                                 i := 0;
                                 while i <= High(VMIDs) do
                                 begin
                                    if VMIDs[i].Name = wst then
                                       Break;
                                    Inc(i);
                                 end;
                                 if i <= High(VMIDs) then
                                 begin
                                    VMName := VMIDs[i].Name;
                                    VMID := VMIDs[i].ID;
                                    VMPath := ws;
                                 end;
                              end
                              else
                              begin
                                 wst := '';
                                 with frmMain.xmlGen do
                                 begin
                                    if Tag = 1 then
                                       try
                                          Active := True;
                                          n1 := ChildNodes.IndexOf('VirtualBox');
                                          if n1 > -1 then
                                          begin
                                             n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                             if n2 > -1 then
                                             begin
                                                n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                if n3 > -1 then
                                                begin
                                                   a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                   if a > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                      Replacebks(wst, Length(wst));
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                    Active := False;
                                 end;

                                 if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(ws, '') + '\' + ws) then
                                 begin
                                    VMPath := wst + '\' + WideChangeFileExt(ws, '') + '\' + ws;
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMID := '';
                                       VMPath := '';
                                    end;
                                 end
                                 else if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) = '') and WideFileExists(wst + '\' + ws + '\' + ws + '.vbox') then
                                 begin
                                    VMPath := wst + '\' + ws + '\' + ws + '.vbox';
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMPath := '';
                                       VMID := '';
                                    end;
                                 end
                                 else if isGUID(ws) then
                                 begin
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].ID = ws then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                       FolderName := '';
                                       with frmMain.xmlGen do
                                       begin
                                          if Tag = 1 then
                                             try
                                                Active := True;
                                                n1 := ChildNodes.IndexOf('VirtualBox');
                                                if n1 > -1 then
                                                begin
                                                   n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                                   if n2 > -1 then
                                                   begin
                                                      n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                      if n3 > -1 then
                                                      begin
                                                         a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                         if a > -1 then
                                                         begin
                                                            FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                            l := Length(FolderName);
                                                            Replacebks(FolderName, l);
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                          Active := False;
                                       end;

                                       if WideDirectoryExists(FolderName) then
                                          VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                                       else
                                          VMPath := '';
                                    end;
                                 end;
                              end;
                           end;
                     end;

                  end
                  else
                  begin
                     ModeLoadVM := 2;
                     VMID := '';
                     VMPath := '';
                     ws := Trim(edtExeParams.Text);
                     p := Pos('-name "', ws);
                     l := Length(ws);
                     if (p > 0) and ((p + 7) < l) then
                     begin
                        cp := PosEx('"', ws, p + 7);
                        if cp > 0 then
                           ws := Trim(Copy(ws, p + 7, cp - p - 7))
                        else
                           ws := '';
                     end
                     else
                        ws := '';
                     VMName := ws;
                  end;
                  ExeParams := Trim(edtExeParams.Text);
                  FirstDriveID := GetDriveID(aDL[cmbFirstDrive.ItemIndex].Number);
                  if cmbFirstDrive.ItemIndex > 0 then
                  begin
                     s := AnsiString(cmbFirstDrive.Text);
                     i := Pos(',  [', s);
                     if i = 0 then
                        FirstDriveName := s
                     else
                        FirstDriveName := Copy(s, 1, i - 1);
                  end
                  else
                     FirstDriveName := '';
                  SecondDriveID := GetDriveID(aDL[cmbSecondDrive.ItemIndex].Number);
                  if cmbSecondDrive.ItemIndex > 0 then
                  begin
                     s := AnsiString(cmbSecondDrive.Text);
                     i := Pos(',  [', s);
                     if i = 0 then
                        SecondDriveName := s
                     else
                        SecondDriveName := Copy(s, 1, i - 1);
                  end
                  else
                     SecondDriveName := '';
                  InternalHDD := Trim(edtHDD.Text);
                  if cmbCDROM.ItemIndex = 0 then
                  begin
                     CDROMName := '';
                     CDROMType := 0;
                  end
                  else if CDDVDType = 0 then
                  begin
                     CDROMName := Copy(cmbCDROM.Text, 1, Length(cmbCDROM.Text) - 6);
                     CDROMType := 0;
                  end
                  else
                  begin
                     CDROMName := TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Text;
                     CDROMType := 1;
                  end;
                  Memory := Min(Max(StrToIntDef(edtMemory.Text, 512), 1), 65535);
                  Audio := cmbAudio.ItemIndex;
                  Run := cmbWS.ItemIndex;
                  VBCPUVirtualization := cmbEnableCPUVirtualization.ItemIndex;
                  Priority := cmbPriority.ItemIndex;
                  luIDS.fdCID := '';
                  luIDS.fdGUID := '';
                  luIDS.sdCID := '';
                  luIDS.sdGUID := '';
                  with lvVMs.Items.Add do
                  begin
                     ImageIndex := Ptype;
                     with SubItems do
                        for i := 1 to lvVMS.Columns.Count - 1 do
                           case lvVMS.Columns[i].Tag of
                              0: Add(IntToStr(lvVMS.Items.Count));
                              1: Add(Name);
                              2: Add(VMName);
                              3: Add(FirstDriveName);
                              4: Add(SecondDriveName);
                           end;
                  end;
                  lvVMS.ItemIndex := lvVMS.Items.Count - 1;
                  lvVMS.Items[lvVMS.Items.Count - 1].Selected := True;
                  lvVMS.Items[lvVMS.Items.Count - 1].Focused := True;
                  lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
                  lvVMS.SetFocus;
               end;

               SaveVMentries(VMentriesFile);
               SaveCfg(CfgFile);
            end;
         end;
      finally
         frmAddEdit.Free;
         frmAddEdit := nil;
      end;
   except
   end;
   btnAdd.Down := False;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
   i, j, abl: Integer;
   ws: WideString;
   c: Char;
   hVolume: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
   SysMenu: HMenu;
begin
   DoubleBuffered := True;
   lvVMs.DoubleBuffered := True;
   lvVMS.Canvas.Font.Assign(lvVms.Font);
   Application.Title := Application.Title + appVersion;
   Caption := Application.Title;
   fOldTWndMethod := WindowProc;
   WindowProc := WindProc;
   lvVMS.Width := Round(ClientWidth - 11 / 9 * btnStart.Width - lvVMS.Left + ClientOrigin.X - Left);
   lvVMS.Height := ClientHeight - 2 * lvVMS.Top;
   abl := Round(ClientWidth - 10 / 9 * btnStart.Width + ClientOrigin.X - Left);
   btnStart.Left := abl;
   btnAdd.Left := abl;
   btnEdit.Left := abl;
   btnDelete.Left := abl;
   btnOptions.Left := abl;
   btnExit.Left := abl;
   btnStart.Top := lvVMS.Top;
   btnExit.Top := lvVMS.Top + lvVMS.Height - btnExit.Height;
   Constraints.MinHeight := 2 * lvVMs.Top + 6 * btnStart.Height + Height - ClientHeight;

   ExeVBPath := GetEnvVarValue('VBOX_INSTALL_PATH');
   if ExeVBPath = '' then
      ExeVBPath := 'C:\Program Files\Oracle\VirtualBox\';
   ExeVBPath := ExeVBPath + 'VirtualBox.exe';
   if not WideFileExists(ExeVBPath) then
      ExeVBPath := '';

   ExeQPath := GetEnvVarValue('QEMU_INSTALL_PATH');
   if ExeQPath <> '' then
      if not WideDirectoryExists(ExeQPath) then
         ExeQPath := '';
   if ExeQPath = '' then
      if WideDirectoryExists('C:\Program Files\qemu\') then
         ExeQPath := 'C:\Program Files\QEMU\'
      else if WideDirectoryExists('C:\Program Files (x86)\qemu\') then
         ExeQPath := 'C:\Program Files (x64)\qemu\';
   if ExeQPath <> '' then
   begin
      if WideFileExists(ExeQPath + 'qemu.exe') then
         ExeQPath := ExeQPath + 'qemu.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-i386.exe') then
         ExeQPath := ExeQPath + 'qemu-system-i386.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-i386w.exe') then
         ExeQPath := ExeQPath + 'qemu-system-i386w.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-x86_64.exe') then
         ExeQPath := ExeQPath + 'qemu-system-x86_64.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-x86_64w.exe') then
         ExeQPath := ExeQPath + 'qemu-system-x86_64w.exe'
      else
         ExeQPath := '';
   end;

   SetLength(VMentries, 0);
   if WideFileExists(VMentriesFile) then
   begin
      LoadVMEntries(VMentriesFile);
      if Length(VMentries) > 0 then
      begin
         lvVMS.Items.BeginUpdate;
         for i := 0 to High(VMentries) do
            lvVMS.Items.Add.ImageIndex := VMentries[i].Ptype;
         i := 1;
         while i < lvVms.Columns.Count do
         begin
            try
               case lvVms.Columns[i].Tag of
                  0:
                     begin
                        if lvVMs.Items.Count < 10 then
                        begin
                           for j := 0 to lvVMS.Items.Count - 1 do
                              lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                        end
                        else
                        begin
                           for j := 0 to lvVMS.Items.Count - 1 do
                              if j < 9 then
                                 lvVMS.Items[j].SubItems.Add('0' + IntToStr(j + 1))
                              else
                                 lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                        end;
                     end;
                  1:
                     for j := 0 to High(VMentries) do
                        lvVMs.Items[j].SubItems.Add(VMentries[j].Name);
                  2:
                     for j := 0 to High(VMentries) do
                        lvVMs.Items[j].SubItems.Add(VMentries[j].VMName);
                  3:
                     for j := 0 to High(VMentries) do
                        lvVMs.Items[j].SubItems.Add(vmEntries[j].FirstDriveName);
                  4:
                     for j := 0 to High(VMentries) do
                        lvVMs.Items[j].SubItems.Add(vmEntries[j].SecondDriveName);
               end;
            except
               try
                  lvVMS.Columns[i].Free;
                  Continue;
               except
               end;
            end;
            Inc(i);
         end;
         lvVMS.Items.EndUpdate;
         lvVMS.ItemIndex := 0;
         lvVms.Items[0].Selected := True;
         lvVms.Items[0].Focused := True;
         lvVMs.Items[0].MakeVisible(False);
      end;
   end;
   OSDrive := 0;
   ws := GetEnvVarValue('SystemDrive');
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   try
      if ws <> '' then
      begin
         c := Char(ws[1]);
         if (c >= 'A') and (c <= 'Z') then
         begin
            try
               hVolume := CreateFile(PAnsiChar('\\.\' + c + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
            except
               hVolume := INVALID_HANDLE_VALUE;
            end;
            if hVolume <> INVALID_HANDLE_VALUE then
            begin
               dwBytesReturned := 0;
               try
                  if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                     OSDrive := sdn.DeviceNumber;
               except
               end;
               try
                  CloseHandle(hVolume);
               except
               end;
            end
         end;
      end;
   finally
      SetErrorMode(ErrorMode);
   end;
   ws := GetEnvVarValue('USERPROFILE');
   if ws <> '' then
   begin
      ws := ws + '\.VirtualBox\VirtualBox.xml';
      if WideFileExists(ws) then
         try
            xmlGen.LoadFromFile(ws);
         except
            xmlGen.Active := False;
         end;
      xmlGen.Tag := Integer(xmlGen.Active);
      xmlGen.Active := False;
   end;
   try
      SysMenu := GetSystemMenu(Handle, False);
      AppendMenu(SysMenu, MF_SEPARATOR, 0, '');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 1, 'Designed by DavidB');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 2, 'Testing and ideas: steve6375');
      AppendMenu(SysMenu, MF_SEPARATOR, 0, '');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 3, 'Latest version and news');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 4, 'Support forum');
   except
   end;
   VBVMWasClosed := Now - 1;
end;

procedure TfrmMain.btnEditClick(Sender: TObject);
var
   i, j, p, l, cp, n1, n2, n3, a: Integer;
   sz: Double;
   hVolume, hDrive: THandle;
   dwBytesReturned, btsIO: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
   ws, wst, FolderName: WideString;
   csz, mu: AnsiString;
   RawMBR: array[0..511] of Byte;
   CanRead: Boolean;
   s: AnsiString;

   procedure Round3;
   var
      k, n: Integer;
   begin
      k := 0;
      if sz < 100 then
      begin
         while sz < 1000 do
         begin
            sz := sz * 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz / 10));
         if k <= 2 then
            Insert(DecimalSeparator, csz, 4 - k)
         else
         begin
            for n := 1 to k - 2 do
               csz := '0' + csz;
            Insert(DecimalSeparator, csz, 2);
         end;
      end
      else if sz > 1000 then
      begin
         while sz > 100 do
         begin
            sz := sz / 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz * 10));
         for n := 1 to k do
            csz := csz + '0';
      end
      else
         csz := IntToStr(Round(sz));
   end;

begin
   if (lvVMS.Items.Count = 0) or (lvVMS.ItemIndex < 0) or (lvVMS.ItemIndex >= lvVMS.Items.Count) then
   begin
      btnEdit.Down := False;
      Exit;
   end;
   try
      try
         if frmAddEdit = nil then
            Application.CreateForm(TfrmAddEdit, frmAddEdit);
         with frmAddEdit do
         begin
            Caption := 'Edit';
            isEdit := True;
            with VMentries[lvVMS.ItemIndex] do
            begin
               edtName.Text := Name;
               cmbMode.ItemIndex := ModeLoadVM;
               if Ptype = 0 then
               begin
                  if rbVirtualBox.Checked then
                     cmbModeChange(cmbMode)
                  else
                     rbVirtualBox.Checked := True;
               end
               else
               begin
                  if rbQEMU.Checked then
                     cmbModeChange(cmbMode)
                  else
                     rbQEMU.Checked := True;
               end;
               edtExeParams.Text := ExeParams;

               GetNamesAndIDs;
               for i := 0 to High(VMIDs) do
                  try
                     cmbVMName.Items.Add('"' + VMIDs[i].Name + '"');
                  except
                  end;

               i := 1;
               while i < cmbVMName.Items.Count do
               begin
                  if cmbVMName.Items[i] = '"' + VMName + '"' then
                     Break;
                  Inc(i);
               end;
               if i < cmbVMName.Items.Count then
                  cmbVMName.ItemIndex := i
               else
                  cmbVMName.ItemIndex := 0;
               edtVMPath.Text := VMPath;
               Refresh;
               ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
               SetLength(aDL, 1);
               aDl[0].Number := -1;
               for i := Byte('A') to Byte('Z') do
               begin
                  try
                     case GetDriveType(PChar(Char(i) + ':\')) of
                        DRIVE_REMOVABLE, DRIVE_FIXED:
                           begin
                              try
                                 hVolume := CreateFile(PAnsiChar('\\.\' + Char(i) + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                              except
                                 hVolume := INVALID_HANDLE_VALUE;
                              end;
                              if hVolume <> INVALID_HANDLE_VALUE then
                              begin
                                 dwBytesReturned := 0;
                                 try
                                    if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                       if sdn.DeviceNumber <> OSDrive then
                                       begin
                                          try
                                             hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(sdn.DeviceNumber)), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                          except
                                             hDrive := INVALID_HANDLE_VALUE;
                                          end;
                                          if hDrive <> INVALID_HANDLE_VALUE then
                                          begin
                                             try
                                                SetFilePointer(hDrive, 512, nil, FILE_BEGIN);
                                                CanRead := ReadFile(hDrive, RawMBR[0], 512, btsIO, nil);
                                             except
                                                CanRead := False;
                                             end;
                                             try
                                                CloseHandle(hDrive);
                                             except
                                             end;
                                             if CanRead then
                                             begin
                                                j := 0;
                                                while j <= High(aDL) do
                                                begin
                                                   if Cardinal(aDL[j].Number) = sdn.DeviceNumber then
                                                      Break;
                                                   Inc(j);
                                                end;
                                                if j > High(aDL) then
                                                begin
                                                   SetLength(adl, Length(adl) + 1);
                                                   aDL[j].Number := sdn.DeviceNumber;
                                                end;
                                                SetLength(aDL[j].Letters, Length(aDL[j].Letters) + 1);
                                                aDL[j].Letters[High(aDL[j].Letters)] := Char(i);
                                             end;
                                          end;
                                       end;
                                 except
                                 end;
                                 try
                                    CloseHandle(hVolume);
                                 except
                                 end;
                              end;
                           end
                     else
                        Continue;
                     end;
                  except
                  end;
               end;
               for i := 0 to MAX_IDE_DRIVES - 1 do
               begin
                  if i = OSDrive then
                     Continue;
                  j := 0;
                  while j <= High(aDL) do
                  begin
                     if aDL[j].Number = i then
                        Break;
                     Inc(j);
                  end;
                  if j > High(aDL) then
                  begin
                     try
                        hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(i)), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                     except
                        hDrive := INVALID_HANDLE_VALUE;
                     end;
                     if hDrive <> INVALID_HANDLE_VALUE then
                     begin
                        try
                           SetFilePointer(hDrive, 512, nil, FILE_BEGIN);
                           CanRead := ReadFile(hDrive, RawMBR[0], 512, btsIO, nil);
                        except
                           CanRead := False;
                        end;
                        try
                           CloseHandle(hDrive);
                        except
                        end;
                        if CanRead then
                        begin
                           SetLength(aDL, Length(aDL) + 1);
                           aDL[High(aDL)].Number := i;
                        end;
                     end;
                  end;
               end;
               if Length(aDl) > 1 then
               begin
                  for i := 1 to High(aDL) do
                  begin
                     ws := GetDriveVendorAndProductID(aDL[i].Number);
                     sz := GetDriveSize(aDL[i].Number) / 1073741824;
                     if sz < 0 then
                     else
                     begin
                        if sz < 1 then
                        begin
                           sz := sz * 1024;
                           mu := ' MB';
                        end
                        else if sz > 1000 then
                        begin
                           sz := sz / 1024;
                           mu := ' TB';
                        end
                        else
                           mu := ' GB';
                        Round3;
                        ws := ws + ', ' + csz + mu;
                     end;
                     ws := ws + ',  [';
                     if Length(aDl[i].Letters) > 0 then
                     begin
                        j := 0;
                        while j < High(aDl[i].Letters) do
                        begin
                           ws := ws + aDl[i].Letters[j] + ', ';
                           Inc(j);
                        end;
                        ws := ws + aDl[i].Letters[j];
                     end;
                     ws := ws + ']';
                     cmbFirstDrive.Items.Add(ws);
                     cmbSecondDrive.Items.Add(ws);
                  end;
               end;
               SetErrorMode(ErrorMode);

               p := FindDriveWithID(FirstDriveID);
               cmbFirstDrive.ItemIndex := 0;
               i := 1;
               while i <= High(aDL) do
               begin
                  if aDL[i].Number = p then
                  begin
                     cmbFirstDrive.ItemIndex := i;
                     Break;
                  end;
                  Inc(i);
               end;
               p := FindDriveWithID(SecondDriveID);
               cmbSecondDrive.ItemIndex := 0;
               i := 1;
               while i <= High(aDL) do
               begin
                  if aDL[i].Number = p then
                  begin
                     cmbSecondDrive.ItemIndex := i;
                     Break;
                  end;
                  Inc(i);
               end;
               cmbEnableCPUVirtualization.ItemIndex := VBCPUVirtualization;
               edtHDD.Text := InternalHDD;
               if Ptype = 1 then
                  if CDROMName <> '' then
                  begin
                     if CDROMType = 0 then
                        cmbCDROM.Items.Add(CDROMName)
                     else
                        cmbCDROM.Items.Add(WideExtractFileName(CDROMName));
                     cmbCDROM.ItemIndex := cmbCDROM.Items.Count - 1;
                  end;
               edtMemory.Text := IntToStr(Memory);
               cmbAudio.ItemIndex := Audio;
               cmbWS.ItemIndex := Run;
               cmbPriority.ItemIndex := Priority;
            end;
            if ShowModal = mrOK then
            begin
               with VMentries[lvVMS.ItemIndex] do
               begin
                  Name := Trim(edtName.Text);
                  Ptype := Byte(not rbVirtualBox.Checked);
                  if rbVirtualBox.Checked then
                  begin
                     ModeLoadVM := cmbMode.ItemIndex;
                     case ModeLoadVM of
                        0:
                           begin
                              VMName := VMIDs[cmbVMName.ItemIndex - 1].Name;
                              VMID := VMIDs[cmbVMName.ItemIndex - 1].ID;
                              FolderName := '';
                              with frmMain.xmlGen do
                              begin
                                 if Tag = 1 then
                                    try
                                       Active := True;
                                       n1 := ChildNodes.IndexOf('VirtualBox');
                                       if n1 > -1 then
                                       begin
                                          n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                          if n2 > -1 then
                                          begin
                                             n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                             if n3 > -1 then
                                             begin
                                                a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                if a > -1 then
                                                begin
                                                   FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                   l := Length(FolderName);
                                                   Replacebks(FolderName, l);
                                                end;
                                             end;
                                          end;
                                       end;
                                    except
                                    end;
                                 Active := False;
                              end;

                              if WideDirectoryExists(FolderName) then
                                 VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                              else
                                 VMPath := '';
                           end;
                        1:
                           begin
                              VMPath := Trim(edtVMPath.Text);
                              VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                              i := 0;
                              while i <= High(VMIDs) do
                              begin
                                 if VMIDs[i].Name = VMName then
                                    Break;
                                 Inc(i);
                              end;
                              VMID := VMIDs[i].ID;
                           end;
                        2:
                           begin
                              ws := Trim(edtExeParams.Text);
                              p := Pos('--startvm "', ws);
                              l := Length(ws);
                              if (p > 0) and ((p + 11) < l) then
                              begin
                                 cp := PosEx('"', ws, p + 11);
                                 if cp > 0 then
                                    ws := Trim(Copy(ws, p + 11, cp - p - 11))
                                 else
                                    ws := '';
                              end
                              else
                                 ws := '';
                              if WideFileExists(ws) then
                              begin
                                 wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                 GetNamesAndIDs;
                                 i := 0;
                                 while i <= High(VMIDs) do
                                 begin
                                    if VMIDs[i].Name = wst then
                                       Break;
                                    Inc(i);
                                 end;
                                 if i <= High(VMIDs) then
                                 begin
                                    VMName := VMIDs[i].Name;
                                    VMID := VMIDs[i].ID;
                                    VMPath := ws;
                                 end;
                              end
                              else
                              begin
                                 wst := '';
                                 with frmMain.xmlGen do
                                 begin
                                    if Tag = 1 then
                                       try
                                          Active := True;
                                          n1 := ChildNodes.IndexOf('VirtualBox');
                                          if n1 > -1 then
                                          begin
                                             n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                             if n2 > -1 then
                                             begin
                                                n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                if n3 > -1 then
                                                begin
                                                   a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                   if a > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                      Replacebks(wst, Length(wst));
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                    Active := False;
                                 end;

                                 if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(ws, '') + '\' + ws) then
                                 begin
                                    VMPath := wst + '\' + WideChangeFileExt(ws, '') + '\' + ws;
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMID := '';
                                       VMPath := '';
                                    end;
                                 end
                                 else if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) = '') and WideFileExists(wst + '\' + ws + '\' + ws + '.vbox') then
                                 begin
                                    VMPath := wst + '\' + ws + '\' + ws + '.vbox';
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMPath := '';
                                       VMID := '';
                                    end;
                                 end
                                 else if isGUID(ws) then
                                 begin
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].ID = ws then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                       FolderName := '';
                                       with frmMain.xmlGen do
                                       begin
                                          if Tag = 1 then
                                             try
                                                Active := True;
                                                n1 := ChildNodes.IndexOf('VirtualBox');
                                                if n1 > -1 then
                                                begin
                                                   n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                                   if n2 > -1 then
                                                   begin
                                                      n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                      if n3 > -1 then
                                                      begin
                                                         a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                         if a > -1 then
                                                         begin
                                                            FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                            l := Length(FolderName);
                                                            Replacebks(FolderName, l);
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                          Active := False;
                                       end;

                                       if WideDirectoryExists(FolderName) then
                                          VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                                       else
                                          VMPath := '';
                                    end;
                                 end;
                              end;
                           end;
                     end;
                  end
                  else
                  begin
                     ModeLoadVM := 2;
                     VMID := '';
                     VMPath := '';
                     ws := Trim(edtExeParams.Text);
                     p := Pos('-name "', ws);
                     l := Length(ws);
                     if (p > 0) and ((p + 7) < l) then
                     begin
                        cp := PosEx('"', ws, p + 7);
                        if cp > 0 then
                           ws := Trim(Copy(ws, p + 7, cp - p - 7))
                        else
                           ws := '';
                     end
                     else
                        ws := '';
                     VMName := ws;
                  end;
                  ExeParams := Trim(edtExeParams.Text);
                  FirstDriveID := GetDriveID(aDL[cmbFirstDrive.ItemIndex].Number);
                  if cmbFirstDrive.ItemIndex > 0 then
                  begin
                     s := AnsiString(cmbFirstDrive.Text);
                     i := Pos(',  [', s);
                     if i = 0 then
                        FirstDriveName := s
                     else
                        FirstDriveName := Copy(s, 1, i - 1);
                  end
                  else
                     FirstDriveName := '';
                  SecondDriveID := GetDriveID(aDL[cmbSecondDrive.ItemIndex].Number);
                  if cmbSecondDrive.ItemIndex > 0 then
                  begin
                     s := AnsiString(cmbSecondDrive.Text);
                     i := Pos(',  [', s);
                     if i = 0 then
                        SecondDriveName := s
                     else
                        SecondDriveName := Copy(s, 1, i - 1);
                  end
                  else
                     SecondDriveName := '';
                  VBCPUVirtualization := cmbEnableCPUVirtualization.ItemIndex;
                  InternalHDD := Trim(edtHDD.Text);
                  if cmbCDROM.ItemIndex = 0 then
                  begin
                     CDROMName := '';
                     CDROMType := 0;
                  end
                  else if CDDVDType = 0 then
                  begin
                     CDROMName := Copy(cmbCDROM.Text, 1, Length(cmbCDROM.Text) - 6);
                     CDROMType := 0;
                  end
                  else
                  begin
                     CDROMName := TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Text;
                     CDROMType := 1;
                  end;
                  Memory := Min(Max(StrToIntDef(edtMemory.Text, 512), 1), 65535);
                  Audio := cmbAudio.ItemIndex;
                  Run := cmbWS.ItemIndex;
                  Priority := cmbPriority.ItemIndex;
                  luIDS.fdCID := '';
                  luIDS.fdGUID := '';
                  luIDS.sdCID := '';
                  luIDS.sdGUID := '';
                  with lvVMS.Items[lvVMS.ItemIndex] do
                  begin
                     ImageIndex := Ptype;
                     for i := 1 to lvVMS.Columns.Count - 1 do
                        case lvVMS.Columns[i].Tag of
                           1: SubItems[i - 1] := Name;
                           2: SubItems[i - 1] := VMName;
                           3: SubItems[i - 1] := FirstDriveName;
                           4: SubItems[i - 1] := SecondDriveName;
                        end;
                  end;
                  lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
               end;

               SaveVMentries(VMentriesFile);
            end;
         end;
      finally
         frmAddEdit.Free;
         frmAddEdit := nil;
      end;
   except
   end;
   btnEdit.Down := False;
end;

procedure TfrmMain.btnDeleteClick(Sender: TObject);
var
   i, li: Integer;
begin
   btnDelete.Down := True;
   try
      if lvVMS.Items.Count = 0 then
         Exit;
      if lvVMS.ItemIndex < 0 then
         Exit;
      if lvVMS.ItemIndex >= lvVMS.Items.Count then
         Exit;
      msgBoxCaption := 'Warning';
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      if MessageBoxW(Handle, 'Are you sure you want to delete this entry..?', 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
      begin
         btnDelete.Down := False;
         Exit;
      end;
      for i := lvVMS.ItemIndex to High(VMentries) - 1 do
         VMentries[i] := VMentries[i + 1];
      SetLength(VMentries, Length(VMentries) - 1);
      li := lvVMS.ItemIndex;
      lvVMS.Items.BeginUpdate;
      lvVMS.DeleteSelected;
      mmCrt.Tag := lvVms.Canvas.TextWidth(IntToStr(Length(VMentries))) + 2 * lvVms.Canvas.TextWidth('0');
      if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
      begin
         if lvVMs.Items.Count < 10 then
         begin
            if lvVMs.Items.Count = 9 then
            begin
               lvVms.Columns[1].MinWidth := 25;
               lvVms.Columns[1].MaxWidth := 25;
               lvVms.Columns[1].Width := 25;
            end;
            for i := 0 to lvVMS.Items.Count - 1 do
               lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end
         else
         begin
            for i := 0 to lvVMS.Items.Count - 1 do
               if i < 9 then
                  lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
               else
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end;
      end;
      lvVMS.Items.EndUpdate;
      if lvVMS.Items.Count > 0 then
      begin
         lvVMS.ItemIndex := Min(li, lvVMS.Items.Count - 1);
         lvVMs.Items[lvVMS.ItemIndex].Selected := True;
         lvVMs.Items[lvVMS.ItemIndex].Focused := True;
         lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
      end;
      SaveVMentries(VMentriesFile);
      SaveCfg(CfgFile);
   finally
      btnDelete.Down := False;
   end;
end;

procedure TfrmMain.MoveUp(Sender: TObject);
var
   i: Integer;
   et: VMEntry;
   vet: TTNTListItem;
   c1, c2: WideString;
begin
   if lvVMS.Items.Count <= 1 then
      Exit;
   i := lvVMS.ItemIndex;
   if i < 1 then
      Exit;
   if i >= lvVMS.Items.Count then
      Exit;

   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      c1 := lvVMS.Items[i - 1].SubItems[0];
      c2 := lvVMS.Items[i].SubItems[0];
   end;
   vet := TTNTListItem.Create(lvVMS.Items);
   vet.Assign(lvVMS.Items[i - 1]);
   lvVMS.Items[i - 1].Assign(lvVMS.Items[i]);
   lvVMS.Items[i].Assign(vet);
   vet.Free;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      lvVMS.Items[i - 1].SubItems[0] := c1;
      lvVMS.Items[i].SubItems[0] := c2;
   end;
   lvVMS.ItemIndex := i - 1;
   lvVMS.Items[i - 1].Selected := True;
   lvVMS.Items[i - 1].Focused := True;

   et := VMentries[i - 1];
   VMentries[i - 1] := VMentries[i];
   VMentries[i] := et;

   SaveVMentries(VMentriesFile);
   SaveCfg(CfgFile);
end;

procedure TfrmMain.MoveDown(Sender: TObject);
var
   i: Integer;
   et: VMEntry;
   vet: TTNTListItem;
   c1, c2: WideString;
begin
   if lvVMS.Items.Count < 1 then
      Exit;
   i := lvVMS.ItemIndex;
   if i < 0 then
      Exit;
   if i>=(lvVMS.Items.Count - 1) then
      Exit;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      c1 := lvVMS.Items[i].SubItems[0];
      c2 := lvVMS.Items[i + 1].SubItems[0];
   end;
   vet := TTNTListItem.Create(lvVMS.Items);
   vet.Assign(lvVMS.Items[i + 1]);
   lvVMS.Items[i + 1].Assign(lvVMS.Items[i]);
   lvVMS.Items[i].Assign(vet);
   vet.Free;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      lvVMS.Items[i].SubItems[0] := c1;
      lvVMS.Items[i + 1].SubItems[0] := c2;
   end;
   lvVMS.ItemIndex := i + 1;
   lvVMS.Items[i + 1].Selected := True;
   lvVMS.Items[i + 1].Focused := True;

   et := VMentries[i + 1];
   VMentries[i + 1] := VMentries[i];
   VMentries[i] := et;

   SaveVMentries(VMentriesFile);
   SaveCfg(CfgFile);
end;

procedure TfrmMain.btnStartClick(Sender: TObject);

   function areDifferent(const FirstXMLnode, SecondXMLnode: IXMLNode): Boolean;
   var
      i: Integer;
   begin
      Result := False;
      try
         if FirstXMLnode.AttributeNodes.Count <> SecondXMLnode.AttributeNodes.Count then
         begin
            Result := True;
            Exit;
         end;
         for i := 0 to FirstXMLnode.AttributeNodes.Count - 1 do
            if FirstXMLnode.AttributeNodes[i].Text <> SecondXMLnode.AttributeNodes[i].Text then
            begin
               Result := True;
               Exit;
            end;
         if FirstXMLnode.ChildNodes.Count <> SecondXMLnode.ChildNodes.Count then
         begin
            Result := True;
            Exit;
         end;
         if FirstXMLnode.ChildNodes.Count = 0 then
            Exit;
         for i := 0 to FirstXMLnode.ChildNodes.Count - 1 do
            if areDifferent(FirstXMLnode.ChildNodes[i], SecondXMLnode.ChildNodes[i]) then
            begin
               Result := True;
               Exit;
            end;
      except
      end;
   end;

const
   ReadBuffer = 2400;
   IOCTL_STORAGE_CHECK_VERIFY2 = $002D0800;
var
   zAppName, zVBM: array[0..512] of WideChar;
   eStartupInfo, vbmStartupInfo: TStartupInfo;
   eProcessInfo, vbmProcessInfo: TProcessInformation;
   ExitCode: DWORD;
   i, j, k, p, cp, l, n1, n2, n3, n4, n5, a1, a2, a3, sc: Integer;
   lv: Int64;
   hVolume, hVBoxSVC, hVmdk, hVbox: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   StartFolder, sf, wst, wp, floc, sloc, ComLine, em, mPort, mDevice, mCName, sJob: WideString;
   CDROMLetter: AnsiChar;
   PStartFolder: PWideChar;
   ErrorMode: Word;
   fu, su: ShortInt;
   AllOK, BreakCycles, isWin, isRightWin, isFUSet, isSUSet, isLastC, DoChange: Boolean;
   vmdkids, exvmdks: array of AnsiString;
   fv, sv, fuuid, suuid, an, sVbox, sVmdk, sOutput: AnsiString;
   ds: Int64;
   ahs: array of array[0..2] of Word;
   sr: TSearchRecW;
   tres: array[0..255] of WideChar;
   attr: Cardinal;
   tms: TMemoryStream;
   wereDismounted, js, VBHardwareVirtualization: Boolean;
   ThreadID, hStderr: THandle;
   WarnAboutBoot: Byte;
   vbmPath: WideString;
   vbmComm: array of WideString;
   Security: TSecurityAttributes;
   ReadPipe, WritePipe: THandle;
   Buffer: Pchar;
   dwBytesRead: DWord;
   bSuccess: LongBool;

label
   sid, srchvbm, srchvm, juststart;
begin
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   fu := -1;
   su := -1;
   wereDismounted := False;
   js := False;
   AllOK := False;
   VBHardwareVirtualization := True;
   try
      if lvVMS.Items.Count < 1 then
         Exit;
      p := lvVMS.ItemIndex;
      if p < 0 then
         Exit;
      if p >= lvVMS.Items.Count then
         Exit;
      Hide;

      if (not StartMessageShowed) and (VMentries[p].Ptype <> 1) then
      begin
         try
            if frmInfoMess = nil then
               Application.CreateForm(TfrmInfoMess, frmInfoMess);
            with frmInfoMess do
            begin
               lblMess.Caption := 'It will take a few seconds to modify the VM configuration file'#13#10'and another few seconds to start it.'#13#10#13#10'So please be patient while I carry out these operations.'#13#10#13#10'Click on OK to continue...';
               cbNoConfirm.Checked := True;
               ShowModal;
               StartMessageShowed := cbNoConfirm.Checked;
            end;
         except
         end;
         try
            if frmInfoMess <> nil then
            begin
               frmInfoMess.Free;
               frmInfoMess := nil;
            end;
         except
         end;
      end;

      with VMentries[p] do
      begin
         SetLength(VolumesInfo, 0);

         if Ptype <> 1 then
         begin
            vbmPath := WideExtractFilePath(ExeVBPath) + 'VBoxManage.exe';

            AllOK := True;
            em := 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.';
            case ModeLoadVM of
               2:
                  begin
                     p := Pos('--startvm "', ExeParams);
                     l := Length(ExeParams);
                     if (p > 0) and ((p + 11) < l) then
                     begin
                        cp := PosEx('"', ExeParams, p + 11);
                        if cp > 0 then
                           sf := Trim(Copy(ExeParams, p + 11, cp - p - 11))
                        else
                           sf := '';
                     end
                     else
                        sf := '';
                     VMPath := '';
                     VMID := '';
                     if sf <> '' then
                        if WideFileExists(sf) then
                           VMPath := sf
                        else
                        begin

                           with frmMain.xmlGen do
                           begin
                              if Tag = 1 then
                                 try
                                    Active := True;
                                    n1 := ChildNodes.IndexOf('VirtualBox');
                                    if n1 > -1 then
                                    begin
                                       n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                       if n2 > -1 then
                                       begin
                                          n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                          if n3 > -1 then
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                             if a1 > -1 then
                                             begin
                                                wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a1].Text;
                                                Replacebks(wst, Length(wst));
                                             end;
                                          end;
                                       end;
                                    end;
                                 except
                                 end;
                              Active := False;
                           end;

                           if (WideExtractFileName(sf) = sf) and (WideExtractFileExt(sf) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(sf, '') + '\' + sf) then
                              VMPath := wst + '\' + WideChangeFileExt(sf, '') + '\' + sf
                           else if (WideExtractFileName(sf) = sf) and (WideExtractFileExt(sf) = '') and WideFileExists(wst + '\' + sf + '\' + sf + '.vbox') then
                              VMPath := wst + '\' + sf + '\' + sf + '.vbox'
                           else if isGUID(sf) then
                           begin
                              VMID := sf;
                              goto sid;
                           end
                           else
                              sf := '';
                        end;
                     if sf = '' then
                     begin
                        AllOK := False;
                        em := 'error retrieving VM path/ID from the exe parameters,'#13#10', please fix the path/ID.';
                     end
                     else if VMPath <> '' then
                     begin
                        VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                        with xmlGen do
                        begin
                           AllOK := False;
                           em := 'error retrieving VM path from Virtualbox.xml,'#13#10'please replace the file or allow reading.';
                           if Tag = 1 then
                              try
                                 Active := True;
                                 n1 := ChildNodes.IndexOf('VirtualBox');
                                 if n1 > -1 then
                                 begin
                                    n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                    if n2 > -1 then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MachineRegistry');
                                       if n3 > -1 then
                                       begin
                                          i := 0;
                                          while i < ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count do
                                          begin
                                             try
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('src');
                                                if a1 > -1 then
                                                begin
                                                   wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                   l := Length(wst);
                                                   if l > 2 then
                                                   begin
                                                      if WideLowerCase(wst) = WideLowerCase(VMPath) then
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                                         if a1 > -1 then
                                                         begin
                                                            wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                            VMID := Copy(wst, 2, Length(wst) - 2);
                                                            AllOK := True;
                                                            Break;
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                             Inc(i);
                                          end;
                                          if (not AllOK) and (i >= ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count) then
                                             em := 'could not find the VM in VirtualBox configuration files,'#13#10'please set a valid VM.';
                                       end;
                                    end;
                                 end;
                              except
                              end;
                           Active := False;
                        end;

                     end;
                  end;
            else
               begin

                  sid:
                  with xmlGen do
                  begin
                     AllOK := False;
                     em := 'error retrieving VM path from Virtualbox.xml,'#13#10'please replace the file or allow reading.';
                     if Tag = 1 then
                        try
                           Active := True;
                           n1 := ChildNodes.IndexOf('VirtualBox');
                           if n1 > -1 then
                           begin
                              n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                              if n2 > -1 then
                              begin
                                 n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MachineRegistry');
                                 if n3 > -1 then
                                 begin
                                    i := 0;
                                    while i < ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count do
                                    begin
                                       try
                                          a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                          if a1 > -1 then
                                          begin
                                             wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                             l := Length(wst);
                                             if l > 2 then
                                             begin
                                                wst := Copy(wst, 2, l - 2);
                                                if wst = VMID then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('src');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                      l := Length(wst);
                                                      if l >= 9 then
                                                      begin
                                                         Replacebks(wst, l);
                                                         VMPath := wst;
                                                         VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                                                         AllOK := True;
                                                      end;
                                                      Break;
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                       Inc(i);
                                    end;
                                    if (not AllOK) and (i >= ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count) then
                                       em := 'could not find the VM in VirtualBox configuration files,'#13#10'please set a valid VM.';
                                 end;
                              end;
                           end;
                        except
                        end;
                     Active := False;
                  end;
               end;
            end;

            try
               GetProcessList;
               l := Length(ProcessInfo);
               if UpdateVM = 1 then
               begin
                  an := '';
                  srchvbm:
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if ProcessInfo[i].WCaption = 'Oracle VM VirtualBox Manager' then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBox(0, PAnsiChar(an + 'VirtualBox Manager was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Should I close it...? (it will take a few sec to fully close)'), 'Warning', MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    if IsWindowVisible(ProcessInfo[i].Handle) then
                                       SendMessage(ProcessInfo[i].Handle, WM_CLOSE, 0, 0);
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if tres <> 'Oracle VM VirtualBox Manager' then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       if IsIconic(ProcessInfo[i].Handle) then
                                          SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       if MessageBox(0, 'Could not close VirtualBox Manager automatically!'#13#10#13#10'Please close it manually and click on OK...  (it will take a few sec to fully close)', 'Error', MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                          Exit
                                       else
                                       begin
                                          j := 1;
                                          while j <= 20 do
                                          begin
                                             Sleep(100);
                                             isRightWin := True;
                                             isWin := isWindow(ProcessInfo[i].Handle);
                                             if isWin then
                                             begin
                                                GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                                if tres <> 'Oracle VM VirtualBox Manager' then
                                                   isRightWin := False
                                                else
                                                begin
                                                   GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                                   if tres <> 'QWidget' then
                                                      isRightWin := False;
                                                end;
                                             end;
                                             if (not isWin) or (not isRightWin) then
                                                Break;
                                             Inc(j);
                                          end;
                                          if j > 20 then
                                          begin
                                             MessageBox(0, 'Error: VirtualBox Manager not closed !', 'Error', MB_ICONERROR or MB_OK);
                                             Exit;
                                          end;
                                       end;
                                    end;
                                 end;
                                 an := 'Another ';
                                 goto srchvbm;
                              end;
               end;

               an := 'A ';
               srchvm:
               if UpdateVM = 1 then
               begin
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if Pos('] - Oracle VM VirtualBox', ProcessInfo[i].WCaption) > 0 then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBox(0, PAnsiChar(an + 'VirtualBox VM was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Please close it and click on OK... (it will take a few sec to fully close)'), 'Warning', MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if Pos('] - Oracle VM VirtualBox', WideString(tres)) = 0 then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       MessageBox(0, 'Error: VirtualBox VM not closed !', 'Error', MB_ICONERROR or MB_OK);
                                       Exit;
                                    end;
                                 end;
                                 an := 'Another ';
                                 GetProcessList;
                                 l := Length(ProcessInfo);
                                 goto srchvm;
                              end;
               end
               else
               begin

                  sOutput := '';
                  with Security do
                  begin
                     nlength := SizeOf(TSecurityAttributes);
                     binherithandle := true;
                     lpsecuritydescriptor := nil;
                  end;
                  if Createpipe(ReadPipe, WritePipe,
                     @Security, 0) then
                  begin
                     Buffer := AllocMem(ReadBuffer + 1);
                     ComLine := vbmPath + ' list runningvms';
                     l := Min(Length(ComLine), 512);
                     for j := 1 to l do
                        zVBM[j - 1] := ComLine[j];
                     for j := l + 1 to SizeOf(zVBM) do
                        zVBM[j - 1] := #0;
                     FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                     vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                     vbmStartupInfo.hStdOutput := WritePipe;
                     vbmStartupInfo.hStdInput := ReadPipe;
                     vbmStartupInfo.dwFlags := STARTF_USESTDHANDLES + STARTF_USESHOWWINDOW;
                     vbmStartupInfo.wShowWindow := SW_HIDE;
                     StartFolder := WideExtractFilePath(ExeVBPath);
                     if StartFolder <> '' then
                        PStartFolder := PWideChar(StartFolder)
                     else
                        PStartFolder := nil;
                     if CreateProcessW(nil,
                        zVBM,
                        @Security,
                        @Security,
                        True,
                        HIGH_PRIORITY_CLASS,
                        nil,
                        PStartFolder,
                        vbmStartupInfo,
                        vbmProcessInfo) then
                     begin
                        ExitCode := Integer(WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT);
                        if ExitCode = 1 then
                        begin
                           ShowingProgress := False;
                           ProgressCancelled := False;
                           try
                              if frmProgress = nil then
                                 Application.CreateForm(TfrmProgress, frmProgress);
                              with frmProgress do
                              begin
                                 lblMessage.Caption := 'Waiting for VBoxManage.exe to finish the current job...';
                                 btnCancel.Caption := 'Cancel';
                                 pbProgress.Max := 100;
                                 Show;
                              end;
                              Application.ProcessMessages;
                              ShowingProgress := True;
                           except
                              try
                                 if frmProgress.Visible then
                                    frmProgress.Close;
                              except
                              end;
                              try
                                 frmProgress.Free;
                                 frmProgress := nil;
                              except
                              end;
                           end;
                           if not ShowingProgress then
                              ExitCode := Integer(WaitForSingleObject(vbmProcessInfo.hProcess, 12000) = WAIT_TIMEOUT)
                           else
                           begin
                              j := 1;
                              while j <= 100 do
                              begin
                                 if ShowingProgress then
                                 begin
                                    frmProgress.pbProgress.Position := j;
                                    Application.ProcessMessages;
                                    if not frmProgress.Visible then
                                    begin
                                       Sleep(100);
                                       Break;
                                    end;
                                 end;
                                 if WaitForSingleObject(vbmProcessInfo.hProcess, 120) <> WAIT_TIMEOUT then
                                    Break;
                                 Inc(j);
                              end;
                              if ShowingProgress then
                                 try
                                    if frmProgress.Visible then
                                       frmProgress.Close;
                                    frmProgress.Free;
                                    frmProgress := nil;
                                 except
                                 end;
                              if (j <= 100) and ProgressCancelled then
                                 ExitCode := 1
                              else if (j > 100) and (not ProgressCancelled) then
                                 ExitCode := 1
                              else
                                 ExitCode := 0;
                           end;
                        end;

                        try
                           if WritePipe <> INVALID_HANDLE_VALUE then
                              ExitCode := Max(Integer(not CloseHandle(WritePipe)), ExitCode);
                        except
                           ExitCode := 1;
                        end;
                        if ExitCode = 0 then
                        begin
                           repeat
                              dwBytesRead := 0;
                              ReadFile(ReadPipe, Buffer[0],
                                 ReadBuffer, dwBytesRead, nil);
                              Buffer[dwBytesRead] := #0;
                              OemToAnsi(Buffer, Buffer);
                              sOutput := sOutput + string(Buffer);
                           until (dwBytesRead < ReadBuffer);
                           ExitCode := 1;
                           try
                              GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                           except
                           end;
                        end;
                        try
                           FreeMem(Buffer);
                           CloseHandle(vbmProcessInfo.hProcess);
                           CloseHandle(vbmProcessInfo.hThread);
                           CloseHandle(ReadPipe);
                        except
                        end;
                        if (ExitCode = 0) and (Pos('{' + VMID + '}', sOutput) > 0) then
                           if MessageBox(0, PAnsiChar('The VirtualBox VM is already started.'#13#10'It has to be closed so its configuration could be changed... !'#13#10#13#10'Please close it and click on OK... (it will take a few sec to fully close)'), 'Warning', MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                              Exit
                           else
                           begin
                              VBVMWasClosed := Now - 1.0 / 86400;
                              goto srchvm;
                           end;
                     end;
                  end;
                  sc := 15000 - Min(15000, Max(0, Round(86400000 * (Now - VBVMWasClosed))));
                  if sc < 1500 then
                     Sleep(sc)
                  else
                  begin
                     ShowingProgress := False;
                     ProgressCancelled := False;
                     try
                        if frmProgress = nil then
                           Application.CreateForm(TfrmProgress, frmProgress);
                        with frmProgress do
                        begin
                           lblMessage.Caption := 'Waiting for the previous VM session to be properly closed...';
                           btnCancel.Caption := 'Skip this (unsafe)';
                           pbProgress.Max := 150;
                           Show;
                        end;
                        Application.ProcessMessages;
                        ShowingProgress := True;
                     except
                        try
                           if frmProgress.Visible then
                              frmProgress.Close;
                        except
                        end;
                        try
                           frmProgress.Free;
                           frmProgress := nil;
                        except
                        end;
                     end;
                     if ShowingProgress then
                     begin
                        j := 1;
                        while j <= 150 do
                        begin
                           if ShowingProgress then
                           begin
                              frmProgress.pbProgress.Position := j;
                              Application.ProcessMessages;
                              if not frmProgress.Visible then
                              begin
                                 Sleep(100);
                                 Break;
                              end;
                           end;
                           n1 := 0;
                           GetProcessList;
                           l := High(ProcessInfo);
                           for k := 0 to l do
                           begin
                              if ProcessInfo[k].WClass = 'QWidget' then
                                 if (ProcessInfo[k].WCaption = 'Oracle VM VirtualBox Manager') or (Pos('] - Oracle VM VirtualBox', ProcessInfo[k].WCaption) > 0) then
                                    if GetFileNameFromHandleW(ProcessInfo[k].Handle) = 'virtualbox.exe' then
                                       if IsWindowVisible(ProcessInfo[k].Handle) then
                                          Inc(n1);
                              if ProcessInfo[k].WClass = 'VBoxPowerNotifyClass' then
                                 if ProcessInfo[k].WCaption = 'VBoxPowerNotifyClass' then
                                    if GetFileNameFromHandleW(ProcessInfo[k].Handle) = 'vboxsvc.exe' then
                                       Dec(n1);
                           end;
                           if n1 = 0 then
                           begin
                              Sleep(100);
                              Break;
                           end;
                           Sleep(sc div 100);
                           Inc(j);
                        end;
                        if ShowingProgress then
                           try
                              if frmProgress.Visible then
                                 frmProgress.Close;
                              frmProgress.Free;
                              frmProgress := nil;
                           except
                           end;
                     end;
                  end;
               end;
            except
            end;

            if UpdateVM = 1 then
               try
                  GetProCessList;
                  j := 0;
                  l := Length(ProcessInfo);
                  while j < l do
                  begin
                     if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                        if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                           if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                              Break;
                     Inc(j);
                  end;
                  if j < l then
                  begin
                     hVBoxSVC := ProcessInfo[j].Handle;
                     ShowingProgress := False;
                     try
                        if frmProgress = nil then
                           Application.CreateForm(TfrmProgress, frmProgress);
                        with frmProgress do
                        begin
                           lblMessage.Caption := 'Waiting for "VBoxSVC.exe" (a VirtualBox component) to close...';
                           btnCancel.Caption := 'Hide';
                           pbProgress.Max := 100;
                           Show;
                        end;
                        Application.ProcessMessages;
                        ShowingProgress := True;
                     except
                        if frmProgress.Visible then
                           frmProgress.Close;
                        frmProgress.Free;
                        frmProgress := nil;
                     end;
                     i := 1;
                     while i <= 100 do
                     begin
                        Sleep(180);
                        if ShowingProgress then
                        begin
                           frmProgress.pbProgress.Position := i;
                           Application.ProcessMessages;
                        end;
                        isRightWin := True;
                        isWin := IsWindow(hVBoxSVC);
                        if isWin then
                        begin
                           GetWindowTextW(hVBoxSVC, tres, 255);
                           if tres <> 'VBoxPowerNotifyClass' then
                              isRightWin := False
                           else
                           begin
                              GetClassNameW(hVBoxSVC, tres, 255);
                              if tres <> 'VBoxPowerNotifyClass' then
                                 isRightWin := False;
                           end;
                        end;
                        if (not isWin) or (not isRightWin) then
                        begin
                           GetProCessList;
                           j := 0;
                           l := Length(ProcessInfo);
                           while j < l do
                           begin
                              if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                 if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                    if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                       Break;
                              Inc(j);
                           end;
                           if j < l then
                              hVBoxSVC := ProcessInfo[j].Handle
                           else
                           begin
                              Sleep(i * 10);
                              Break;
                           end;
                        end;
                        Inc(i);
                     end;
                     if ShowingProgress then
                        try
                           if frmProgress.Visible then
                              frmProgress.Close;
                           frmProgress.Free;
                           frmProgress := nil;
                        except
                        end;
                     if i > 100 then
                     begin
                        if MessageBox(0, PAnsiChar('Out of time waiting for "VBoxSVC.exe" (a VirtualBox component) to close...!'#13#10#13#10'Should I forcebly close it...?'), 'Error', MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                           Exit
                        else
                        begin
                           j := 0;
                           GetProcessList;
                           l := Length(ProcessInfo);
                           while j < l do
                           begin
                              if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                 if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                    if GetFileNameAndThreadFromHandleW(ProcessInfo[j].Handle, ThreadID) = 'vboxsvc.exe' then
                                       try
                                          TerminateProcess(OpenProcess(PROCESS_TERMINATE, BOOL(0), ThreadID), 0);
                                       except
                                       end;
                              Inc(j);
                           end;
                           for i := 1 to 10 do
                           begin
                              Sleep(200);
                              j := 0;
                              GetProcessList;
                              l := Length(ProcessInfo);
                              while j < l do
                              begin
                                 if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                    if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                       if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                          Break;
                                 Inc(j);
                              end;
                              if j >= l then
                                 Break;
                           end;
                           if i <= 10 then
                           begin
                              MessageBox(0, '"VBoxSVC.exe" is still open !'#13#10#13#10'Exiting...', 'Error', MB_ICONERROR or MB_OK);
                              Exit;
                           end;
                        end;
                     end;
                  end;

               except
               end;

         end;

         fu := FindDriveWithID(FirstDriveID);
         if fu = -1 then
            if AddSecondDrive then
            begin
               if MessageBox(0, PAnsiChar('The first drive (' + FirstDriveName + ') doesn''t seem'#13#10'to exist on this system or it isn''t accessible !'#13#10#13#10' Are you sure you want to continue...? '), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            end
            else if MessageBox(0, PAnsiChar('The drive (' + FirstDriveName + ') doesn''t seem'#13#10'to exist on this system or it isn''t accessible !'#13#10#13#10' Are you sure you want to continue...? '), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
               Exit;

         if AddSecondDrive and (SecondDriveID <> '') then
         begin
            su := FindDriveWithID(SecondDriveID);
            if su = -1 then
               if MessageBox(0, PAnsiChar('The second drive (' + SecondDriveName + ') doesn''t seem'#13#10'to exist on this system or it isn''t accessible !'#13#10#13#10' Are you sure you want to continue...? '), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
         end
         else
            su := -1;

         for i := Byte('A') to Byte('Z') do
         begin
            try
               case GetDriveType(PAnsiChar(Char(i) + ':\')) of
                  DRIVE_REMOVABLE, DRIVE_FIXED:
                     begin
                        try
                           hVolume := CreateFile(PAnsiChar('\\.\' + Char(i) + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                        except
                           hVolume := INVALID_HANDLE_VALUE;
                        end;
                        if hVolume <> INVALID_HANDLE_VALUE then
                        begin
                           dwBytesReturned := 0;
                           try
                              if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                 if Integer(sdn.DeviceNumber) = fu then
                                 begin
                                    SetLength(VolumesInfo, Length(VolumesInfo) + 1);
                                    VolumesInfo[High(VolumesInfo)].Letter := Char(i);
                                    VolumesInfo[High(VolumesInfo)].DriveProp := FirstDriveName;
                                 end
                                 else if Integer(sdn.DeviceNumber) = su then
                                 begin
                                    SetLength(VolumesInfo, Length(VolumesInfo) + 1);
                                    VolumesInfo[High(VolumesInfo)].Letter := Char(i);
                                    VolumesInfo[High(VolumesInfo)].DriveProp := SecondDriveName;
                                 end;
                           except
                           end;
                           try
                              CloseHandle(hVolume);
                           except
                           end;
                        end;
                     end
               else
                  Continue;
               end;
            except
            end
         end;

         for i := 0 to High(VolumesInfo) do
         begin
            try
               VolumesInfo[i].Handle := CreateFile(PAnsiChar('\\.\' + VolumesInfo[i].Letter + ':'), GENERIC_READ or GENERIC_WRITE,
                  FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
            except
               VolumesInfo[i].Handle := INVALID_HANDLE_VALUE;
            end;
            if VolumesInfo[i].Handle = INVALID_HANDLE_VALUE then
            begin
               LastError := GetLastError;
               if MessageBoxW(0, PWideChar('Unable to access volume ''' + VolumesInfo[i].Letter + ''' on "' + VolumesInfo[i].DriveProp + '" !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError) + #13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit
               else
                  Continue;
            end;
            FlushToDisk(VolumesInfo[i].Handle);
            Sleep(FlushWaitTime);
            if LockVolumes and (not LockVolume(VolumesInfo[i])) and (not ProgressCancelled) and (MessageBoxW(0, PWideChar('Unable to lock volume ''' + VolumesInfo[i].Letter + ''' on "' + VolumesInfo[i].DriveProp + '" !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError) + #13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes) then
               Exit
            else if not DisMountVolume(VolumesInfo[i].Handle) then
               if MessageBoxW(0, PWideChar('Unable to dismount volume ''' + VolumesInfo[i].Letter + ''' on "' + VolumesInfo[i].DriveProp + '" !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError) + #13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
         end;
         wereDismounted := True;

         if Ptype = 1 then
         begin
            StartFolder := WideExtractFilePath(ExeQPath);
            if SecondDriveID = '' then
               ComLine := '"' + ExeQPath + '" ' + ' -drive file=\\.\PhysicalDrive' + IntToStr(fu) + ',if=ide,index=0,media=disk,snapshot=off ' + ExeParams
            else
               ComLine := '"' + ExeQPath + '" ' + ' -drive file=\\.\PhysicalDrive' + IntToStr(fu) + ',if=ide,index=0,media=disk,snapshot=off' + ' -drive file=\\.\PhysicalDrive' + IntToStr(su) + ',if=ide,index=1,media=disk,snapshot=off ' + ExeParams;
            if InternalHDD <> '' then
               if WideFileExists(InternalHDD) then
               begin
                  if SecondDriveID = '' then
                     ComLine := ComLine + ' -hdb "' + InternalHDD + '"'
                  else if CDROMName = '' then
                     ComLine := ComLine + ' -hdc "' + InternalHDD + '"'
                  else
                     ComLine := ComLine + ' -hdd "' + InternalHDD + '"';
               end
               else if MessageBoxW(0, PWideChar('Unable to find "' + InternalHDD + '"'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            if CDROMName <> '' then
               if CDROMType = 0 then
               begin
                  CDROMLetter := AnsiChar(CharLower(PAnsiChar(FindCDROMLetter(CDROMName))));
                  if CDROMLetter <> '0' then
                  begin
                     try
                        hVolume := CreateFile(PAnsiChar('\\.\' + CDROMLetter + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                     except
                        hVolume := INVALID_HANDLE_VALUE;
                     end;
                     if hVolume = INVALID_HANDLE_VALUE then
                     begin
                        if MessageBoxW(0, PWideChar('Cannot access the "' + CDROMName + '" !'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                           Exit;
                     end
                     else
                     begin
                        try
                           bSuccess := DeviceIoControl(hVolume, IOCTL_STORAGE_CHECK_VERIFY2, nil, 0, nil, 0, dwBytesRead, nil);
                        except
                           bSuccess := False;
                        end;
                        try
                           CloseHandle(hVolume);
                        except
                        end;
                        if not bSuccess then
                           if MessageBoxW(0, PWideChar('Cannot access the medium from "' + CDROMName + '" !'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                              Exit;
                     end;
                     ComLine := ComLine + ' -cdrom ' + CDROMLetter + ':';
                  end
                  else if MessageBoxW(0, PWideChar('"' + CDROMName + '" doesn''t exist on this system, it is not mounted or it is not accessible !'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                     Exit;
               end
               else if WideFileExists(CDROMName) then
                  ComLine := ComLine + ' -cdrom "' + CDROMName + '"'
               else if MessageBoxW(0, PWideChar('Unable to find "' + CDROMName + '" !'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            ComLine := ComLine + ' -m ' + IntToStr(Memory);
            case Audio of
               1: ComLine := ComLine + ' -soundhw sb16';
               2: ComLine := ComLine + ' -soundhw pcspk';
               3: ComLine := ComLine + ' -soundhw hda';
               4: ComLine := ComLine + ' -soundhw gus';
               5: ComLine := ComLine + ' -soundhw es1370';
               6: ComLine := ComLine + ' -soundhw cs4231a';
               7: ComLine := ComLine + ' -soundhw adlib';
               8: ComLine := ComLine + ' -soundhw ac97';
            end;
         end
         else
         begin
            StartFolder := WideExtractFilePath(ExeVBPath);
            if (fu >= 0) or (su >= 0) then
            begin
               if AllOK then
               begin
                  em := 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.';
                  try
                     xmlVBox.LoadFromFile(VMPath);
                  except
                     on E: Exception do
                     begin
                        AllOK := False;
                        em := 'error accesing "' + VMPath + '",'#13#10'please allow access to it.'#13#10'System message: ' + E.Message;
                        xmlVBox.Active := False;
                     end;
                  end;
                  xmlVBox.Tag := Integer(xmlVBox.Active);

                  if xmlVBox.Active then
                  begin
                     tms := TMemoryStream.Create;
                     try
                        xmlVBox.SaveToStream(tms);
                        xmlVboxCompare.LoadFromStream(tms);
                     except
                     end;
                     xmlVBoxCompare.Tag := Integer(xmlVBoxCompare.Active);
                     tms.Free;

                     SetLength(vmdkids, 0);
                     SetLength(exvmdks, 0);

                     WarnAboutBoot := 1;

                     with xmlVBox do
                     begin
                        if Tag = 1 then
                           try
                              n1 := ChildNodes.IndexOf('VirtualBox');
                              if n1 = -1 then
                              begin
                                 em := '"VirtualBox" section not found in the vbox file !';
                                 Abort;
                              end
                              else
                              begin
                                 n2 := ChildNodes[n1].ChildNodes.IndexOf('Machine');
                                 if n2 = -1 then
                                 begin
                                    em := '"Machine" section not found in the vbox file !';
                                    Abort;
                                 end
                                 else
                                 begin
                                    a1 := ChildNodes[n1].ChildNodes[n2].AttributeNodes.IndexOf('stateFile');
                                    if a1 > -1 then
                                    begin
                                       MessageBox(0, 'It appears that this VM is in a saved state so it will not be modified, only started...'#13#10#13#10'Just so you know, it is not a good idea to save the state of a VM with a real drive,'#13#10'because it will increase the risk of corrupting the data from that drive...', 'Warning', MB_OK or MB_ICONWARNING);
                                       js := True;
                                       Abort;
                                    end;
                                    n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MediaRegistry');
                                    if n3 = -1 then
                                    begin
                                       em := '"MediaRegistry" section not found in the vbox file !';
                                       Abort;
                                    end
                                    else
                                    begin
                                       n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('HardDisks');
                                       if n4 > -1 then
                                       begin
                                          for i := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 downto 0 do
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('format');
                                             if a1 = -1 then
                                                Continue;
                                             if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text = 'VMDK' then
                                             begin
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('location');
                                                if a2 > -1 then
                                                begin
                                                   wp := WideLowerCase(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text);
                                                   l := Length(wp);
                                                   if l <> 17 then
                                                      Continue;
                                                   if Pos('vmubdrive', wp) <> 1 then
                                                      Continue;
                                                   if StrToIntDef('$' + Copy(wp, 10, 3), -1) = -1 then
                                                      Continue;
                                                   if Pos('.vmdk', wp) <> 13 then
                                                      Continue;
                                                   a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                                   if a3 > -1 then
                                                   begin
                                                      if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count > 0 then
                                                      begin
                                                         em := 'the content of "' + ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text + '" is divided into ' + IntToStr(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count) + ' snapshot(s).' +
                                                            #13#10'It is not a good idea using snapshots with real drives. But if you really want to at least do this:'#13#10 +
                                                            'If you created a snapshot or linked clone this VM you should of manually detached any'#13#10'VMUBDrive***.vmdk drive from the storage controller(s) before the snapshoting/cloning operation.';
                                                         Abort;
                                                      end;
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a3].Text;
                                                      SetLength(vmdkids, Length(vmdkids) + 1);
                                                      vmdkids[High(vmdkids)] := Copy(wst, 2, Length(wst) - 2);
                                                      ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Delete(i);
                                                      SetLength(vbmComm, Length(vbmComm) + 1);
                                                      vbmComm[High(vbmComm)] := 'closemedium disk ' + Copy(wst, 2, Length(wst) - 2);
                                                   end;
                                                end;
                                             end;
                                          end;
                                          for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 do
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                             if a1 > -1 then
                                             begin
                                                wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text;
                                                SetLength(exvmdks, Length(exvmdks) + 1);
                                                exvmdks[High(exvmdks)] := Copy(wst, 2, Length(wst) - 2);
                                             end;
                                          end;
                                       end;
                                    end;
                                    if Length(vmdkids) > 0 then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('StorageControllers');
                                       if n3 > -1 then
                                          for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                                             for j := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Count - 1 downto 0 do
                                             begin
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('name');
                                                if a1 > -1 then
                                                   mCName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text
                                                else
                                                   mCName := 'IDE';
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('port');
                                                if a2 > -1 then
                                                   mPort := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a2].Text
                                                else
                                                   mPort := '0';
                                                a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('device');
                                                if a3 > -1 then
                                                   mDevice := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a3].Text
                                                else
                                                   mDevice := '0';
                                                n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes.IndexOf('Image');
                                                if n4 > -1 then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes.IndexOf('uuid');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes[a1].Text;
                                                      wst := Copy(wst, 2, Length(wst) - 2);
                                                      k := 0;
                                                      while k < Length(vmdkids) do
                                                      begin
                                                         if vmdkids[k] = wst then
                                                         begin
                                                            WarnAboutBoot := 0;
                                                            ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Delete(j);
                                                            SetLength(vbmComm, Length(vbmComm) + 1);
                                                            for p := High(vbmComm) downto 1 do
                                                               vbmComm[p] := vbmComm[p - 1];

                                                            if (a1 > -1) and (a2 > -1) and (a3 > -1) then
                                                               vbmComm[0] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + mPort + ' --device ' + mDevice + ' --medium none';
                                                            Break;
                                                         end;
                                                         Inc(k);
                                                      end;
                                                   end;
                                                end;
                                             end;

                                    end;
                                    if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('Hardware');
                                       if n3 > -1 then
                                       begin
                                          VBHardwareVirtualization := False;
                                          n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('CPU');
                                          if n4 > -1 then
                                          begin
                                             n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.IndexOf('HardwareVirtEx');
                                             if n5 > -1 then
                                             begin
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].AttributeNodes.IndexOf('enabled');
                                                VBHardwareVirtualization := (a1 > -1) and (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].AttributeNodes[a1].Text = 'true');
                                             end;
                                          end;
                                       end;
                                    end;
                                 end;
                              end;
                              AllOK := True;
                           except
                              if em = 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.' then
                                 em := 'error accesing xml structure from "' + VMPath + '",'#13#10'please repair the file or replace it with a backup copy.';
                              AllOK := False;
                           end;

                        if not AllOK then
                           Active := False;
                        if js then
                           goto juststart;
                     end;

                  end;

                  if AllOK then
                  begin

                     if fu >= 0 then
                     begin
                        if luIDS.fdCID = '' then
                           luIDS.fdCID := GenID;
                        fv := defvmdk[1] + luIDS.fdCID + defvmdk[2];
                        ds := GetDriveSize(fu);
                        if ds = -1 then
                           ds := 4294967296
                        else
                           ds := ds div 512;
                        fuuid := '';
                        if luIDS.fdGUID <> '' then
                           fuuid := luIDS.fdGUID
                        else
                           fuuid := GenGuid;
                        while True do
                        begin
                           i := 0;
                           while i < Length(exvmdks) do
                           begin
                              if exvmdks[i] = fuuid then
                                 Break;
                              Inc(i);
                           end;
                           if i >= Length(exvmdks) then
                              Break;
                           fuuid := GenGuid;
                        end;
                        luIDS.fdGUID := fuuid;
                        SetLength(exvmdks, Length(exvmdks) + 1);
                        exvmdks[High(exvmdks)] := fuuid;
                        fv := fv + IntToStr(ds) + defvmdk[3] + IntToStr(fu) + defvmdk[4] +
                           IntToStr(Min(16383, ds div 1008)) + defvmdk[5] + fuuid + defvmdk[6];
                     end
                     else
                        fv := '';

                     if su >= 0 then
                     begin
                        if luIDS.sdCID = '' then
                           while True do
                           begin
                              luIDS.sdCID := GenID;
                              if luIDS.sdCID <> luIDS.fdCID then
                                 Break;
                           end;
                        sv := defvmdk[1] + luIDS.sdCID + defvmdk[2];
                        ds := GetDriveSize(su);
                        if ds = -1 then
                           ds := 4294967296
                        else
                           ds := ds div 512;
                        suuid := '';
                        if luIDS.sdGUID <> '' then
                           suuid := luIDS.sdGUID
                        else
                           suuid := GenGuid;
                        while True do
                        begin
                           i := 0;
                           while i < Length(exvmdks) do
                           begin
                              if exvmdks[i] = suuid then
                                 Break;
                              Inc(i);
                           end;
                           if i >= Length(exvmdks) then
                              Break;
                           suuid := GenGuid;
                        end;
                        luIDS.sdGUID := suuid;
                        sv := sv + IntToStr(ds) + defvmdk[3] + IntToStr(su) + defvmdk[4] +
                           IntToStr(Min(16383, ds div 1008)) + defvmdk[5] + suuid + defvmdk[6];
                     end
                     else
                        sv := '';

                     isFUSet := fu < 0;
                     isSUSet := su < 0;

                     sf := WideExtractFilePath(VMPath);
                     try
                        if WideFindFirst(sf + 'VMUBDrive???.vmdk', faAnyFile, sr) = 0 then
                        begin
                           repeat
                              try
                                 if StrToIntDef('$' + Copy(sr.Name, 9, 3), -1) <> -1 then
                                 begin
                                    if not isFUSet then
                                    begin
                                       floc := sf + sr.Name;
                                       sVmdk := '';
                                       try
                                          hVmdk := CreateFileW(PWideChar(floc), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                       except
                                          hVmdk := INVALID_HANDLE_VALUE;
                                       end;
                                       if hVmdk <> INVALID_HANDLE_VALUE then
                                       begin
                                          try
                                             lv := GetFileSize(hVmdk, nil);
                                          except
                                             lv := $FFFFFFFF;
                                          end;
                                          if lv <> $FFFFFFFF then
                                          begin
                                             SetLength(sVmdk, lv);
                                             try
                                                ReadFile(hVmdk, Pointer(sVmdk)^, lv, dwBytesReturned, nil);
                                             except
                                                dwBytesReturned := 0;
                                             end;
                                             if lv = dwBytesReturned then
                                                if Pos(fv, sVmdk) = 1 then
                                                   isFUSet := True;
                                          end;
                                          try
                                             CloseHandle(hVmdk);
                                          except
                                          end;
                                          if not isFUSet then
                                             WideDeleteFile(sf + sr.Name);
                                       end;
                                    end
                                    else if not isSUSet then
                                    begin
                                       sloc := sf + sr.Name;
                                       sVmdk := '';
                                       try
                                          hVmdk := CreateFileW(PWideChar(sloc), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                       except
                                          hVmdk := INVALID_HANDLE_VALUE;
                                       end;
                                       if hVmdk <> INVALID_HANDLE_VALUE then
                                       begin
                                          try
                                             lv := GetFileSize(hVmdk, nil);
                                          except
                                             lv := $FFFFFFFF;
                                          end;
                                          if lv <> $FFFFFFFF then
                                          begin
                                             SetLength(sVmdk, lv);
                                             try
                                                ReadFile(hVmdk, Pointer(sVmdk)^, lv, dwBytesReturned, nil);
                                             except
                                                dwBytesReturned := 0;
                                             end;
                                             if lv = dwBytesReturned then
                                                if Pos(sv, sVmdk) = 1 then
                                                   isSUSet := True;
                                          end;
                                          try
                                             CloseHandle(hVmdk);
                                          except
                                          end;
                                          if not isSUSet then
                                             WideDeleteFile(sf + sr.Name);
                                       end;
                                    end
                                    else
                                       WideDeleteFile(sf + sr.Name);

                                 end;
                              except
                              end;
                           until WideFindNext(sr) <> 0;
                           WideFindClose(sr);
                        end;
                     except
                     end;

                     if not isFUSet then
                     begin
                        i := 0;
                        while i < 4096 do
                        begin
                           floc := sf + 'VMUBDrive' + IntToHex(i, 3) + '.vmdk';
                           if not WideFileExists(floc) then
                              Break;
                           Inc(i);
                        end;
                        if i < 4096 then
                        begin
                           hVmdk := INVALID_HANDLE_VALUE;
                           try
                              hVmdk := CreateFileW(PWideChar(floc), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                              if hVmdk <> INVALID_HANDLE_VALUE then
                              begin
                                 lv := Length(fv);
                                 if not WriteFile(hVmdk, Pointer(fv)^, lv, dwBytesReturned, nil) then
                                 begin
                                    LastError := GetLastError;
                                    em := 'error writing in "' + floc + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                 end
                                 else
                                 begin
                                    try
                                       FlushFileBuffers(hVmdk);
                                    except
                                    end;
                                    if Cardinal(lv) <> dwBytesReturned then
                                    begin
                                       LastError := GetLastError;
                                       em := 'error writing in "' + floc + '",'#13#10'please free some space or check the volume "' + WideExtractFileDrive(floc) + '" for errors.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                    end
                                    else
                                       isFUSet := True;
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 em := 'error writing in "' + floc + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                              end;
                           except
                              on E: Exception do
                                 em := 'error writing in "' + floc + '",'#13#10'please remove the write protection or check the volume "' + WideExtractFileDrive(floc) + '" for errors.'#13#10'System message: ' + E.Message;
                           end;
                           try
                              if hVmdk <> INVALID_HANDLE_VALUE then
                                 CloseHandle(hVmdk);
                           except
                           end;
                           Sleep(200);
                        end
                        else
                           em := 'unable to find an unused vmdk file name in'#13#10'"VMUBDrive000..VMUBDriveFFF" range. Please detach and delete the unused ones.'#13#10'You can do that by starting the VirtualBox Manager, then the VirtualBox Media Manager'#13#10'and deleting one ore more VMUBDrive***.vmdk.';
                     end;

                     if not isSUSet then
                     begin
                        i := 0;
                        while i < 4096 do
                        begin
                           sloc := sf + 'VMUBDrive' + IntToHex(i, 3) + '.vmdk';
                           if not WideFileExists(sloc) then
                              Break;
                           Inc(i);
                        end;
                        if i < 4096 then
                        begin
                           hVmdk := INVALID_HANDLE_VALUE;
                           try
                              hVmdk := CreateFileW(PWideChar(sloc), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                              if hVmdk <> INVALID_HANDLE_VALUE then
                              begin
                                 lv := Length(sv);
                                 if not WriteFile(hVmdk, Pointer(sv)^, lv, dwBytesReturned, nil) then
                                 begin
                                    LastError := GetLastError;
                                    em := 'error writing in "' + sloc + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                 end
                                 else
                                 begin
                                    try
                                       FlushFileBuffers(hVmdk);
                                    except
                                    end;
                                    if Cardinal(lv) <> dwBytesReturned then
                                    begin
                                       LastError := GetLastError;
                                       em := 'error writing in "' + sloc + '",'#13#10'please free some space or check the volume "' + WideExtractFileDrive(sloc) + '" for errors.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                    end
                                    else
                                       isSUSet := True;
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 em := 'error writing in "' + sloc + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                              end;
                           except
                              on E: Exception do
                                 em := 'error writing in "' + sloc + '",'#13#10'please remove the write protection or check the volume "' + WideExtractFileDrive(sloc) + '" for errors.'#13#10#13#10'System message: ' + E.Message;
                           end;
                           try
                              if hVmdk <> INVALID_HANDLE_VALUE then
                                 CloseHandle(hVmdk);
                           except
                           end;
                           Sleep(200);
                        end
                        else
                           em := 'unable to find an unused vmdk file name in'#13#10'"VMUBDrive000..VMUBDriveFFF" range. Please detach and delete the unused ones.'#13#10'You can do that by starting the VirtualBox Manager, then the VirtualBox Media Manager'#13#10'and deleting one ore more VMUBDrive***.vmdk.';
                     end;

                     AllOK := isFUSet and isSUSet;

                     if AllOK then
                     begin
                        em := 'error accesing xml structure of "' + VMPath + '",'#13#10'please repair the file or replace it with a backup copy.';
                        with xmlVBox do
                        begin
                           if Tag = 1 then
                              try
                                 n1 := ChildNodes.IndexOf('VirtualBox');
                                 if n1 = -1 then
                                 begin
                                    em := '"VirtualBox" section not found in the vbox file !';
                                    Abort;
                                 end
                                 else
                                 begin
                                    n2 := ChildNodes[n1].ChildNodes.IndexOf('Machine');
                                    if n2 = -1 then
                                    begin
                                       em := '"Machine" section not found in the vbox file !';
                                       Abort;
                                    end
                                    else
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MediaRegistry');
                                       if n3 = -1 then
                                       begin
                                          em := '"MediaRegistry" section not found in the vbox file !';
                                          Abort;
                                       end
                                       else
                                       begin
                                          n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('HardDisks');
                                          if n4 > -1 then
                                          begin
                                             if fu >= 0 then
                                                with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardDisk') do
                                                begin
                                                   SetAttribute('uuid', '{' + fuuid + '}');
                                                   SetAttribute('location', WideExtractFileName(floc));
                                                   SetAttribute('format', 'VMDK');
                                                   SetAttribute('type', 'Normal');
                                                end;
                                             if su >= 0 then
                                                with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardDisk') do
                                                begin
                                                   SetAttribute('uuid', '{' + suuid + '}');
                                                   SetAttribute('location', WideExtractFileName(sloc));
                                                   SetAttribute('format', 'VMDK');
                                                   SetAttribute('type', 'Normal');
                                                end;
                                          end;
                                       end;
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('StorageControllers');
                                       isFUSet := fu < 0;
                                       isSUSet := su < 0;
                                       if n3 > -1 then
                                          if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count > 0 then
                                          begin
                                             for sc := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                                             begin
                                                if isFUSet and isSUSet then
                                                   Break;
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('name');
                                                if a2 > -1 then
                                                   mCName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a2].Text
                                                else
                                                   mCName := 'IDE';
                                                isLastC := sc = (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1);
                                                if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count = 0 then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                   p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;
                                                   if (fu >= 0) and (not isFUSet) then
                                                      if (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count + 1) > p then
                                                      begin
                                                         if isLastC then
                                                         begin
                                                            if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                               em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.'
                                                            else
                                                               em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                            Abort;
                                                         end
                                                         else
                                                            Continue;
                                                      end
                                                      else
                                                      begin
                                                         a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count;
                                                         with xmlVBox.ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                         begin
                                                            SetAttribute('type', 'HardDisk');
                                                            SetAttribute('port', IntToStr(a2));
                                                            SetAttribute('device', '0');
                                                            with AddChild('Image') do
                                                               SetAttribute('uuid', '{' + fuuid + '}');
                                                         end;
                                                         SetLength(vbmComm, Length(vbmComm) + 1);
                                                         vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                            ' --port ' + IntToStr(a2) + ' --device 0 --type hdd --medium "' + floc + '"';
                                                      end;
                                                   if (su >= 0) and (not isSUSet) then
                                                      if (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count + 1) > p then
                                                      begin
                                                         if isLastC then
                                                         begin
                                                            if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                               em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.'
                                                            else
                                                               em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                            Abort;
                                                         end
                                                         else
                                                            Continue;
                                                      end
                                                      else
                                                      begin
                                                         a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count;
                                                         with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                         begin
                                                            SetAttribute('type', 'HardDisk');
                                                            SetAttribute('port', IntToStr(a2));
                                                            SetAttribute('device', '0');
                                                            with AddChild('Image') do
                                                               SetAttribute('uuid', '{' + suuid + '}');
                                                         end;
                                                         SetLength(vbmComm, Length(vbmComm) + 1);
                                                         vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                            ' --port ' + IntToStr(a2) + ' --device 0 --type hdd --medium "' + sloc + '"';
                                                      end;
                                                   Break;
                                                end
                                                else
                                                begin
                                                   SetLength(ahs, 0);
                                                   for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count - 1 do
                                                   begin
                                                      a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('port');
                                                      a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('device');
                                                      a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('type');
                                                      if (a1 > -1) and (a2 > -1) and (a3 > -1) then
                                                      begin
                                                         SetLength(ahs, Length(ahs) + 1);
                                                         ahs[High(ahs)][0] := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a1].NodeValue;
                                                         ahs[High(ahs)][1] := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a2].NodeValue;
                                                         ahs[High(ahs)][2] := Integer(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a3].Text = 'HardDisk');
                                                      end;
                                                   end;
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('type');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].Text;
                                                      if (wst = 'PIIX3') or (wst = 'PIIX4') or (wst = 'ICH6') then
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                         p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;
                                                         if (fu >= 0) and (not isFUSet) then
                                                         begin
                                                            if Length(ahs)<(2 * p) then
                                                            begin
                                                               i := 0;
                                                               j := 0;
                                                               BreakCycles := False;
                                                               while i < p do
                                                               begin
                                                                  j := 0;
                                                                  while j < p do
                                                                  begin
                                                                     k := 0;
                                                                     while k < Length(ahs) do
                                                                     begin
                                                                        if (ahs[k][0] = i) and (ahs[k][1] = j) then
                                                                           Break;
                                                                        Inc(k);
                                                                     end;
                                                                     if k >= Length(ahs) then
                                                                     begin
                                                                        BreakCycles := True;
                                                                        Break;
                                                                     end
                                                                     else if WarnAboutBoot = 1 then
                                                                        if ahs[k][2] = 1 then
                                                                           WarnAboutBoot := 2;
                                                                     Inc(j);
                                                                  end;
                                                                  if BreakCycles then
                                                                     Break;
                                                                  Inc(i);
                                                               end;

                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', IntToStr(j));
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + fuuid + '}');
                                                                  SetLength(ahs, Length(ahs) + 1);
                                                                  ahs[High(ahs)][0] := i;
                                                                  ahs[High(ahs)][1] := j;
                                                                  isFUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device ' + IntToStr(j) + ' --type hdd --medium "' + floc + '"';
                                                            end
                                                            else
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and deleting one or more drives from the IDE controller.'
                                                                  else
                                                                     em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end;
                                                         end;
                                                         if (su >= 0) and (not isSUSet) then
                                                         begin
                                                            if Length(ahs)<(2 * p) then
                                                            begin
                                                               i := 0;
                                                               j := 0;
                                                               BreakCycles := False;
                                                               while i < p do
                                                               begin
                                                                  j := 0;
                                                                  while j < p do
                                                                  begin
                                                                     k := 0;
                                                                     while k < Length(ahs) do
                                                                     begin
                                                                        if (ahs[k][0] = i) and (ahs[k][1] = j) then
                                                                           Break;
                                                                        Inc(k);
                                                                     end;
                                                                     if k >= Length(ahs) then
                                                                     begin
                                                                        BreakCycles := True;
                                                                        Break;
                                                                     end;
                                                                     Inc(j);
                                                                  end;
                                                                  if BreakCycles then
                                                                     Break;
                                                                  Inc(i);
                                                               end;
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', IntToStr(j));
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + suuid + '}');
                                                                  isSUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device ' + IntToStr(j) + ' --type hdd --medium "' + sloc + '"';
                                                            end
                                                            else
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and deleting one or more drives from the IDE controller.'
                                                                  else
                                                                     em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end;
                                                         end;
                                                      end
                                                      else
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                         p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;

                                                         if (fu >= 0) and (not isFUSet) then
                                                         begin
                                                            i := 0;
                                                            BreakCycles := False;
                                                            while i < p do
                                                            begin
                                                               j := 0;
                                                               while j < Length(ahs) do
                                                               begin
                                                                  if ahs[j][0] = i then
                                                                     Break;
                                                                  Inc(j);
                                                               end;
                                                               if j >= Length(ahs) then
                                                               begin
                                                                  BreakCycles := True;
                                                                  Break;
                                                               end
                                                               else if WarnAboutBoot = 1 then
                                                                  if ahs[j][2] = 1 then
                                                                     WarnAboutBoot := 2;
                                                               Inc(i);
                                                            end;
                                                            if not BreakCycles then
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.'
                                                                  else
                                                                     em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end
                                                            else
                                                            begin
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', '0');
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + fuuid + '}');
                                                                  SetLength(ahs, Length(ahs) + 1);
                                                                  ahs[High(ahs)][0] := i;
                                                                  ahs[High(ahs)][1] := 0;
                                                                  isFUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device 0 --type hdd --medium "' + floc + '"';
                                                            end;
                                                         end;

                                                         if (su >= 0) and (not isSUSet) then
                                                         begin
                                                            i := 0;
                                                            BreakCycles := False;
                                                            while i < p do
                                                            begin
                                                               j := 0;
                                                               while j < Length(ahs) do
                                                               begin
                                                                  if ahs[j][0] = i then
                                                                     Break;
                                                                  Inc(j);
                                                               end;
                                                               if j >= Length(ahs) then
                                                               begin
                                                                  BreakCycles := True;
                                                                  Break;
                                                               end;
                                                               Inc(i);
                                                            end;
                                                            if not BreakCycles then
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     em := 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.'
                                                                  else
                                                                     em := 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.';
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end
                                                            else
                                                            begin
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', '0');
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + suuid + '}');
                                                                  isSUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device 0 --type hdd --medium "' + sloc + '"';
                                                            end;
                                                         end;
                                                      end;
                                                   end;
                                                end;

                                             end;
                                          end
                                          else
                                          begin
                                             em := 'unable to find a storage controller in the VirtualBox VM,'#13#10'please add one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and adding a storage controller.';
                                             Abort;
                                          end;
                                       if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) and (UpdateVM = 1) then
                                       begin
                                          n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('Hardware');
                                          if n3 > -1 then
                                          begin
                                             n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('CPU');
                                             if n4 = -1 then
                                             begin
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AddChild('CPU');
                                                n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1;
                                             end;
                                             n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.IndexOf('HardwareVirtEx');
                                             if n5 = -1 then
                                             begin
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardwareVirtEx');
                                                n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1;
                                             end;
                                             if ((VBCPUVirtualization = 1) and (not VBHardwareVirtualization)) or ((VBCPUVirtualization = 3) and (not VBHardwareVirtualization)) then
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].SetAttribute('enabled', 'true')
                                             else if ((VBCPUVirtualization = 2) and VBHardwareVirtualization) or ((VBCPUVirtualization = 3) and VBHardwareVirtualization) then
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].SetAttribute('enabled', 'false');
                                          end;
                                       end;
                                    end;
                                 end;

                                 AllOK := True;
                              except
                                 AllOK := False;
                              end;

                           if AllOK then
                              if WarnAboutBoot = 2 then
                                 if AddSecondDrive then
                                 begin
                                    if MessageBox(0, PAnsiChar('It seems this VM won''t be able to boot from the first drive (' + FirstDriveName + ')'#13#10'because other drive(s) is/are attached to the storage controller in prior position(s).'#13#10#13#10 +
                                       'My advice is to free a port in the storage controller before the other drive(s).' +
                                        #13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and moving the other drive(s) into subsequent port(s) in the storage controller.'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYES then
                                       Exit;
                                 end
                                 else if MessageBox(0, PAnsiChar('It seems this VM won''t be able to boot from the drive (' + FirstDriveName + ')'#13#10'because other drive(s) is/are attached to the storage controller in prior position(s).'#13#10#13#10 +
                                    'My advice is to free a port in the storage controller before the other drive(s).' +
                                    #13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and moving the other drive(s) into subsequent port(s) in the storage controller.'#13#10#13#10'Are you sure you want to continue...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYES then
                                    Exit;

                           if not AllOK then
                              Active := False
                           else
                           begin
                              if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) and (UpdateVM = 0) then
                              begin
                                 DoChange := False;
                                 if ((VBCPUVirtualization = 1) and (not VBHardwareVirtualization)) or ((VBCPUVirtualization = 3) and (not VBHardwareVirtualization)) then
                                 begin
                                    DoChange := True;
                                    VBHardwareVirtualization := True;
                                 end
                                 else if ((VBCPUVirtualization = 2) and VBHardwareVirtualization) or ((VBCPUVirtualization = 3) and VBHardwareVirtualization) then
                                 begin
                                    DoChange := True;
                                    VBHardwareVirtualization := False;
                                 end;
                                 if DoChange then
                                 begin
                                    if VBHardwareVirtualization then
                                       sJob := 'modifyvm ' + VMID + ' --hwvirtex on'
                                    else
                                       sJob := 'modifyvm ' + VMID + ' --hwvirtex off';
                                    ComLine := vbmPath + ' ' + sJob;
                                    l := Min(Length(ComLine), 512);
                                    for j := 1 to l do
                                       zVBM[j - 1] := ComLine[j];
                                    for j := l + 1 to SizeOf(zVBM) do
                                       zVBM[j - 1] := #0;
                                    FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                                    vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                                    vbmStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                    vbmStartupInfo.wShowWindow := SW_HIDE;
                                    StartFolder := WideExtractFilePath(ExeVBPath);
                                    if StartFolder <> '' then
                                       PStartFolder := PWideChar(StartFolder)
                                    else
                                       PStartFolder := nil;
                                    if CreateProcessW(nil,
                                       zVBM,
                                       nil,
                                       nil,
                                       False,
                                       DETACHED_PROCESS or
                                       HIGH_PRIORITY_CLASS,
                                       nil,
                                       PStartFolder,
                                       vbmStartupInfo,
                                       vbmProcessInfo) then
                                    begin
                                       if WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT then
                                       begin
                                          ShowingProgress := False;
                                          ProgressCancelled := False;
                                          try
                                             if frmProgress = nil then
                                                Application.CreateForm(TfrmProgress, frmProgress);
                                             with frmProgress do
                                             begin
                                                lblMessage.Caption := 'Waiting for VBoxManage.exe to finish the current job...';
                                                btnCancel.Caption := 'Cancel';
                                                pbProgress.Max := 100;
                                                Show;
                                             end;
                                             Application.ProcessMessages;
                                             ShowingProgress := True;
                                          except
                                             if frmProgress.Visible then
                                                frmProgress.Close;
                                             frmProgress.Free;
                                             frmProgress := nil;
                                          end;
                                          if not ShowingProgress then
                                          begin
                                             if WaitForSingleObject(vbmProcessInfo.hProcess, 12000) = WAIT_TIMEOUT then
                                             begin
                                                em := 'Out of time waiting for VBoxManage.exe to finish the current job !'#13#10#13#10'Job = ' + sJob;
                                                AllOK := False;
                                             end;
                                          end
                                          else
                                          begin
                                             j := 1;
                                             while j <= 100 do
                                             begin
                                                if ShowingProgress then
                                                begin
                                                   frmProgress.pbProgress.Position := j;
                                                   Application.ProcessMessages;
                                                   if not frmProgress.Visible then
                                                   begin
                                                      Sleep(100);
                                                      Break;
                                                   end;
                                                end;
                                                if WaitForSingleObject(vbmProcessInfo.hProcess, 120) <> WAIT_TIMEOUT then
                                                   Break;
                                                Inc(j);
                                             end;
                                             if ShowingProgress then
                                                try
                                                   if frmProgress.Visible then
                                                      frmProgress.Close;
                                                   frmProgress.Free;
                                                   frmProgress := nil;
                                                except
                                                end;
                                             if (j <= 100) and ProgressCancelled then
                                             begin
                                                em := 'Waiting for VBoxManage.exe to finish the current job was cancelled by the user !'#13#10#13#10'Job = ' + sJob;
                                                AllOK := False;
                                             end
                                             else if (j > 100) and (not ProgressCancelled) then
                                             begin
                                                em := 'Out of time waiting for VBoxManage.exe to finish the current job !'#13#10#13#10'Job = ' + sJob;
                                                AllOK := False;
                                             end;
                                          end;
                                       end;
                                       if AllOK then
                                       begin
                                          ExitCode := 9999;
                                          try
                                             GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                                          except
                                          end;
                                          if ExitCode > 0 then
                                          begin
                                             AllOK := False;
                                             if ExitCode <> 9999 then
                                                em := 'VBoxManage.exe returned error code ' + IntToStr(ExitCode) + ' for the current job !'#13#10#13#10'Job = ' + sJob
                                             else
                                                em := 'Error getting the exit code for the current VBoxManage job !'#13#10#13#10'Job = ' + sJob;
                                          end;
                                          try
                                             CloseHandle(vbmProcessInfo.hProcess);
                                             CloseHandle(vbmProcessInfo.hThread);
                                          except
                                          end;
                                       end;
                                    end
                                    else
                                    begin
                                       LastError := GetLastError;
                                       em := 'Unable to launch VBoxManage.exe !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                       AllOK := False;
                                    end;
                                 end;
                              end;

                              if AllOK and ((xmlVBoxCompare.Tag = 0) or areDifferent(xmlVBox.DocumentElement, xmlVBoxCompare.DocumentElement)) then
                              begin
                                 if UpdateVM = 1 then
                                 begin
                                    try
                                       if WideFileExists(VMPath + '-prev') then
                                       begin
                                          attr := GetFileAttributesW(PWideChar(VMPath + '-prev'));
                                          if attr <> $FFFFFFFF then
                                          begin
                                             if SetFileAttributesW(PWideChar(VMPath + '-prev'), attr - FILE_ATTRIBUTE_READONLY) then
                                                if WideDeleteFile(VMPath + '-prev') then
                                                   if WideRenameFile(VMPath, VMPath + '-prev') then
                                                      SetFileAttributesW(PWideChar(VMPath + '-prev'), attr);
                                          end;
                                       end
                                       else
                                       begin
                                          if WideRenameFile(VMPath, VMPath + '-prev') then
                                             SetFileAttributesW(PWideChar(VMPath + '-prev'), FILE_ATTRIBUTE_READONLY);
                                       end;
                                    except
                                    end;
                                    try
                                       sVbox := XML.Text;
                                       hVbox := CreateFileW(PWideChar(FileName), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                                       if hVbox <> INVALID_HANDLE_VALUE then
                                       begin
                                          if not WriteFile(hVbox, Pointer(sVbox)^, Length(sVbox), dwBytesReturned, nil) then
                                          begin
                                             LastError := GetLastError;
                                             em := 'error writing in "' + FileName + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                             AllOK := False;
                                          end
                                          else
                                          begin
                                             try
                                                FlushFileBuffers(hVbox);
                                             except
                                             end;
                                             if Cardinal(Length(sVbox)) <> dwBytesReturned then
                                             begin
                                                LastError := GetLastError;
                                                em := 'error writing in "' + FileName + '",'#13#10'please free some space or check the volume "' + WideExtractFileDrive(FileName) + '" for errors.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                                AllOK := False;
                                             end
                                             else
                                                AllOK := True;
                                          end;
                                       end
                                       else
                                       begin
                                          LastError := GetLastError;
                                          em := 'error writing in "' + FileName + '",'#13#10'please remove the write protection.'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                          AllOK := False;
                                       end;
                                    except
                                       on E: Exception do
                                       begin
                                          AllOK := False;
                                          em := 'error writing in "' + FileName + '",'#13#10'please remove the write protection or check the volume "' + WideExtractFileDrive(FileName) + '" for errors.'#13#10#13#10'System message: ' + E.Message;
                                       end;
                                    end;
                                    try
                                       if hVbox <> INVALID_HANDLE_VALUE then
                                          CloseHandle(hVbox);
                                    except
                                    end;
                                    Sleep(200);
                                    Active := False;
                                 end
                                 else
                                 begin
                                    if Active then
                                       Active := False;
                                    i := 0;
                                    while i <= High(vbmComm) do
                                    begin
                                       ComLine := vbmPath + ' ' + vbmComm[i];
                                       l := Min(Length(ComLine), 512);
                                       for j := 1 to l do
                                          zVBM[j - 1] := ComLine[j];
                                       for j := l + 1 to SizeOf(zVBM) do
                                          zVBM[j - 1] := #0;
                                       FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                                       vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                                       vbmStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                       vbmStartupInfo.wShowWindow := SW_HIDE;
                                       StartFolder := WideExtractFilePath(ExeVBPath);
                                       if StartFolder <> '' then
                                          PStartFolder := PWideChar(StartFolder)
                                       else
                                          PStartFolder := nil;
                                       if CreateProcessW(nil,
                                          zVBM,
                                          nil,
                                          nil,
                                          False,
                                          DETACHED_PROCESS or
                                          HIGH_PRIORITY_CLASS,
                                          nil,
                                          PStartFolder,
                                          vbmStartupInfo,
                                          vbmProcessInfo) then
                                       begin
                                          if WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT then
                                          begin
                                             ShowingProgress := False;
                                             ProgressCancelled := False;
                                             try
                                                if frmProgress = nil then
                                                   Application.CreateForm(TfrmProgress, frmProgress);
                                                with frmProgress do
                                                begin
                                                   lblMessage.Caption := 'Waiting for VBoxManage.exe to finish the current job...';
                                                   btnCancel.Caption := 'Cancel';
                                                   pbProgress.Max := 100;
                                                   Show;
                                                end;
                                                Application.ProcessMessages;
                                                ShowingProgress := True;
                                             except
                                                if frmProgress.Visible then
                                                   frmProgress.Close;
                                                frmProgress.Free;
                                                frmProgress := nil;
                                             end;
                                             if not ShowingProgress then
                                             begin
                                                if WaitForSingleObject(vbmProcessInfo.hProcess, 12000) = WAIT_TIMEOUT then
                                                begin
                                                   em := 'Out of time waiting for VBoxManage.exe to finish the current job !'#13#10#13#10'Job = ' + vbmComm[i];
                                                   AllOK := False;
                                                   Break;
                                                end;
                                             end
                                             else
                                             begin
                                                j := 1;
                                                while j <= 100 do
                                                begin
                                                   if ShowingProgress then
                                                   begin
                                                      frmProgress.pbProgress.Position := j;
                                                      Application.ProcessMessages;
                                                      if not frmProgress.Visible then
                                                      begin
                                                         Sleep(100);
                                                         Break;
                                                      end;
                                                   end;
                                                   if WaitForSingleObject(vbmProcessInfo.hProcess, 120) <> WAIT_TIMEOUT then
                                                      Break;
                                                   Inc(j);
                                                end;
                                                if ShowingProgress then
                                                   try
                                                      if frmProgress.Visible then
                                                         frmProgress.Close;
                                                      frmProgress.Free;
                                                      frmProgress := nil;
                                                   except
                                                   end;
                                                if (j <= 100) and ProgressCancelled then
                                                begin
                                                   em := 'Waiting for VBoxManage.exe to finish the current job was cancelled by the user !'#13#10#13#10'Job = ' + vbmComm[i];
                                                   AllOK := False;
                                                   Break;
                                                end
                                                else if (j > 100) and (not ProgressCancelled) then
                                                begin
                                                   em := 'Out of time waiting for VBoxManage.exe to finish the current job !'#13#10#13#10'Job = ' + vbmComm[i];
                                                   AllOK := False;
                                                   Break;
                                                end;
                                             end;
                                          end;
                                          ExitCode := 9999;
                                          try
                                             GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                                          except
                                          end;
                                          if ExitCode > 0 then
                                          begin
                                             AllOK := False;
                                             if ExitCode <> 9999 then
                                                em := 'VBoxManage.exe returned error code ' + IntToStr(ExitCode) + ' for the current job !'#13#10#13#10'Job = ' + vbmComm[i]
                                             else
                                                em := 'Error getting the exit code for the current VBoxManage job !'#13#10#13#10'Job = ' + vbmComm[i];
                                             Break;
                                          end;
                                          try
                                             CloseHandle(vbmProcessInfo.hProcess);
                                             CloseHandle(vbmProcessInfo.hThread);
                                          except
                                          end;
                                       end
                                       else
                                       begin
                                          LastError := GetLastError;
                                          em := 'Unable to launch VBoxManage.exe !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError);
                                          AllOK := False;
                                          Break;
                                       end;
                                       Inc(i);
                                    end;

                                 end;
                              end;
                           end;
                        end;
                     end;
                     if xmlVBoxCompare.Tag = 1 then
                        xmlVBoxCompare.Active := False;
                  end;
               end;
               if not AllOK then
               begin
                  l := Length(em);
                  i := l;
                  while i > 0 do
                  begin
                     if (em[i] <> #13) and (em[i] <> #10) then
                        Break;
                     Dec(i);
                  end;
                  Delete(em, i + 1, l - i);
                  if MessageBoxW(0, PWideChar('Could not automatically add the drive(s) to the VM in VirtualBox.'#13#10#13#10'Possible reason: ' + em + #13#10#13#10'Are you sure you want to continue (not recommended)...?'), 'Warning', MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                     Exit;
               end;
            end;

            juststart:

            if Run = 3 then
               sf := ' --fullscreen'
            else
               sf := '';
            case ModeLoadVM of
               1: ComLine := ExeVBPath + ' --startvm "' + VMPath + '"' + sf;
               2: ComLine := ExeVBPath + ' ' + ExeParams + sf;
            else
               ComLine := ExeVBPath + ' --startvm "' + VMID + '"' + sf;
            end;
         end;
         FillChar(eStartupInfo, Sizeof(eStartupInfo), #0);
         eStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
         eStartupInfo.cb := Sizeof(eStartupInfo);
         case Run of
            1: eStartupInfo.wShowWindow := SW_MINIMIZE;
            2: eStartupInfo.wShowWindow := SW_MAXIMIZE;
            3: if Ptype = 0 then
                  eStartupInfo.wShowWindow := SW_SHOWNORMAL
               else
                  eStartupInfo.wShowWindow := SW_HIDE;
         else
            eStartupInfo.wShowWindow := SW_SHOWNORMAL;
         end;
         case Priority of
            0: cp := $000004000;
            2: cp := $000008000;
            3: cp := $000000080;
         else
            cp := $000000020;
         end;
         if StartFolder <> '' then
            PStartFolder := PWideChar(StartFolder)
         else
            PStartFolder := nil;
         if Ptype <> 1 then
         begin
            l := Min(Length(ComLine), 512);
            for i := 1 to l do
               zAppName[i - 1] := ComLine[i];
            if CreateProcessW(nil,
               zAppName,
               nil,
               nil,
               False,
               CREATE_NEW_CONSOLE or
               cp,
               nil,
               PStartFolder,
               eStartupInfo,
               eProcessInfo) then
            begin
               WaitforSingleObject(eProcessInfo.hProcess, INFINITE);
               VBVMWasClosed := Now;
               try
                  if not GetExitCodeProcess(eProcessInfo.hProcess, ExitCode) then
                     ExitCode := 1;
               except
                  ExitCode := 1;
               end;
               try
                  CloseHandle(eProcessInfo.hProcess);
                  CloseHandle(eProcessInfo.hThread);
               except
               end;
               Sleep(200);
            end
            else
            begin
               LastError := GetLastError;
               MessageBoxW(0, PWideChar('Unable to launch VirtualBox !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError)), 'Error', MB_ICONERROR or MB_OK);
            end;
         end
         else
         begin
            l := Min(Length(ComLine), 512);
            for i := 1 to l do
               zAppName[i - 1] := ComLine[i];
            if CreateProcessW(nil,
               zAppName,
               nil,
               nil,
               True,
               CREATE_NEW_CONSOLE or cp,
               nil,
               PStartFolder,
               eStartupInfo,
               eProcessInfo) then
            begin
               WaitforSingleObject(eProcessInfo.hProcess, INFINITE);
               try
                  if not GetExitCodeProcess(eProcessInfo.hProcess, ExitCode) then
                     ExitCode := 1;
               except
                  ExitCode := 1;
               end;
               try
                  CloseHandle(eProcessInfo.hProcess);
                  CloseHandle(eProcessInfo.hThread);
               except
               end;
               if ExitCode >= 1 then
               begin
                  TntClipboard.AsWideText := ComLine + #13#10'pause';
                  MessageBox(0, 'QEMU returned error !'#13#10#13#10'Tip: you should check the command line parameters'#13#10'to see if any are missing or spelled wrong.'#13#10'If you are using the default parameters'#13#10'you should adapt them to your QEMU version.' +
                     #13#10#13#10'To get more informations the command line was copied into clipboard.'#13#10'Create a new bat/cmd file, paste from clipboard and start it (as an administrator).' +
                     #13#10#13#10'On QEMU newer versions you could check the content of the stderr.txt file from'#13#10'the QEMU folder (where the QEMU exe file resides).', 'Warning', MB_OK or MB_ICONWARNING);
               end
               else
                  Sleep(200);
            end
            else
            begin
               LastError := GetLastError;
               MessageBoxW(0, PWideChar('Unable to launch QEMU !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError)), 'Error', MB_ICONERROR or MB_OK);
            end;
         end;
      end;
   finally
      for i := 0 to High(VolumesInfo) do
         try
            if VolumesInfo[i].Handle <> INVALID_HANDLE_VALUE then
               CloseHandle(VolumesInfo[i].Handle);
         except
         end;
      if wereDismounted then
      begin
         if fu > 0 then
            UpdateDrive(fu);
         if su > 0 then
            UpdateDrive(su);
      end;
      SetErrorMode(ErrorMode);
      btnStart.Down := False;
      Show;
   end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
   SaveVMentries(VMentriesFile);
   SaveCFG(CfgFile);
end;

procedure TfrmMain.lvVMsDragDrop(Sender, Source: TObject; X, Y: Integer);
var
   dropItem: TListItem;
   Rect: TRect;
   i, cp, dp: Integer;
   currentItem: TTntListItem;
   et: VMEntry;
begin
   try
      if Sender = Source then
      begin
         with TTNTListView(Sender) do
         begin
            dropItem := GetItemAt(X, Y);
            if Selected <> nil then
            begin
               dp := 0;
               try
                  currentItem := Items.Add;
                  currentItem.Assign(Selected);
                  if not Assigned(dropItem) then
                  begin
                     if Y < Items[0].DisplayRect(drBounds).Top then
                        dp := 0
                     else if Y > Items[Items.Count - 1 - SelCount].DisplayRect(drBounds).Bottom then
                        dp := Items.Count - 2;
                  end;
                  Items.BeginUpdate;
                  cp := ItemIndex;
                  et := VMEntries[cp];
                  DeleteSelected;
                  if Assigned(dropItem) then
                  begin
                     Rect := dropItem.DisplayRect(drBounds);
                     if Y<(Rect.Top + (Rect.Bottom - Rect.Top) div 2) then
                        dp := dropItem.Index
                     else
                        dp := dropItem.Index + 1;
                  end;
                  Items.Insert(dp).Assign(currentItem);
                  currentItem.Free;
                  if dp < cp then
                  begin
                     for i := cp - 1 downto dp do
                        VMEntries[i + 1] := VMEntries[i];
                  end
                  else
                     for i := cp + 1 to dp do
                        VMEntries[i - 1] := VMEntries[i];
                  VMEntries[dp] := et;
               finally
                  if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
                     if lvVMS.Items.Count < 10 then
                     begin
                        for i := 0 to lvVMS.Items.Count - 1 do
                           lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
                     end
                     else
                        for i := 0 to lvVMS.Items.Count - 1 do
                           if i < 9 then
                              lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
                           else
                              lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
                  Items.EndUpdate;
                  Items[dp].Focused := True;
                  ItemIndex := dp;
                  Items[dp].Selected := True;
                  SaveVMentries(VMentriesFile);
                  SaveCfg(CfgFile);
               end;
            end;
         end;
      end;
   except
   end;
end;

procedure TfrmMain.lvVMsDragOver(Sender, Source: TObject; X, Y: Integer;
   State: TDragState; var Accept: Boolean);
var
   dropItem: TListItem;
begin
   try
      Accept := False;
      if Sender <> Source then
         Exit;
      if (Sender as TTntListView).SelCount = (Sender as TTntListView).Items.Count then
         Exit;
      dropItem := (Sender as TTntListView).GetItemAt(X, Y);
      if (dropItem <> nil) and dropItem.Selected then
         Exit;
      Accept := True;
   except
   end;
end;

procedure TfrmMain.TntFormMouseDown(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: Integer);
begin
   ReleaseCapture;
   SendMessage(Handle, WM_SYSCOMMAND, 61458, 0);
end;

procedure TfrmMain.WindProc(var Message: TMessage);
begin
   try
      if Message.Msg = WM_SYSCOMMAND then
         case Message.wParam of
            SC_MINIMIZE:
               if WindowState = wsNormal then
               begin
                  IntLeft := Left;
                  IntTop := Top;
                  IntWidth := Width;
                  IntHeight := Height;
               end;
            SC_MAXIMIZE:
               begin
                  if WindowState = wsNormal then
                  begin
                     IntLeft := Left;
                     IntTop := Top;
                     IntWidth := Width;
                     IntHeight := Height;
                  end;
                  SaveMaximized := True;
               end;
            WM_USER + 1: OpenInternetHelp(Self.Handle, ['http://reboot.pro/user/61891-davidb/', 'http://reboot.pro/index.php?showuser=61891']);
            WM_USER + 2: OpenInternetHelp(Self.Handle, ['http://reboot.pro/user/17818-steve6375/', 'http://reboot.pro/index.php?showuser=17818']);
            WM_USER + 3: OpenInternetHelp(Self.Handle, ['http://reboot.pro/files/file/339-virtual-machine-usb-boot/', 'http://reboot.pro/index.php?s=e6a62f6faf7bc2a4ed6d16b703166a34&app=downloads&showfile=339']);
            WM_USER + 4: OpenInternetHelp(Self.Handle, DefSiteHelp);
         end;
   except
   end;
   fOldTwndMethod(Message);
end;

procedure TfrmMain.TntFormResize(Sender: TObject);
var
   i, l, pl, iname, ivmname, ifirst, isec, nres: Integer;
   diff, t: Double;
begin
   try
      i := 0;
      l := 0;
      iname := -1;
      ivmname := -1;
      ifirst := -1;
      isec := -1;
      nres := 0;
      while i < lvVMS.Columns.Count do
      begin
         case lvVMS.Columns[i].Tag of
            1:
               begin
                  iname := i;
                  Inc(nres);
               end;
            2:
               begin
                  ivmname := i;
                  Inc(nres);
               end;
            3:
               begin
                  ifirst := i;
                  Inc(nres);
               end;
            4:
               begin
                  isec := i;
                  Inc(nres);
               end;
         else
            Inc(l, lvVMS.Columns[i].Width);
         end;
         Inc(i);
      end;
      lvVMs.Columns.BeginUpdate;
      if nres > 0 then
      begin
         l := lvVMS.ClientWidth - l - 1;
         pl := 0;
         if iname > -1 then
            Inc(pl, lvVMS.Columns[iname].Width);
         if ivmname > -1 then
            Inc(pl, lvVMS.Columns[ivmname].Width);
         if ifirst > -1 then
            Inc(pl, lvVMS.Columns[ifirst].Width);
         if isec > -1 then
            Inc(pl, lvVMS.Columns[isec].Width);
         diff := 1.0 * (l - pl) / nres;
         if iname > -1 then
            lvVMS.Columns[iname].Width := Round(diff + lvVMS.Columns[iname].Width);
         if ivmname > -1 then
            lvVMS.Columns[ivmname].Width := Round(diff + lvVMS.Columns[ivmname].Width);
         if ifirst > -1 then
            lvVMS.Columns[ifirst].Width := Round(diff + lvVMS.Columns[ifirst].Width);
         if isec > -1 then
            lvVMS.Columns[isec].Width := Round(diff + lvVMS.Columns[isec].Width);
      end;
      lvVMs.Columns.EndUpdate;
   except
   end;
   t := 0.2 * (btnExit.Top - btnStart.Top);
   btnAdd.Top := Round(t + btnStart.Top);
   btnEdit.Top := Round(2.0 * t + btnStart.Top);
   btnDelete.Top := Round(3.0 * t + btnStart.Top);
   btnOptions.Top := Round(4.0 * t + btnStart.Top);
end;

procedure TfrmMain.pmHeadersPopup(Sender: TObject);
var
   i: Integer;
begin
   for i := 0 to pmHeaders.Items.Count - 1 do
      if pmHeaders.Items[i].Visible then
         try
            pmHeaders.Items[i].Checked := False;
         except
         end;
   for i := 1 to lvVMS.Columns.Count - 1 do
      try
         if pmHeaders.Items[lvVMS.Columns[i].Tag].Visible then
            pmHeaders.Items[lvVMS.Columns[i].Tag].Checked := True;
      except
      end;
end;

procedure TfrmMain.mmHeadersClick(Sender: TObject);
var
   i, j: Integer;
begin
   (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
   lvVMs.Items.BeginUpdate;
   lvVMs.Columns.BeginUpdate;
   try
      if (Sender as TMenuItem).Checked then
      begin
         for i := lvVMs.Columns.Count - 1 downto 1 do
            lvVMs.Columns[i].Free;
         for i := 0 to lvVMS.Items.Count - 1 do
            lvVMS.Items[i].SubItems.Clear;
         for i := 0 to pmHeaders.Items.Count - 1 do
            if pmHeaders.Items[i].Checked and pmHeaders.Items[i].Visible then
               with lvVMS.Columns.Add do
               begin
                  Caption := pmHeaders.Items[i].Caption;
                  MinWidth := 50;
                  Tag := i;
                  case Tag of
                     0:
                        begin
                           Alignment := taCenter;
                           pmHeaders.Items[i].Tag := lvVms.Canvas.TextWidth(IntToStr(Length(VMentries)) + '00');
                           MinWidth := pmHeaders.Items[i].Tag;
                           MaxWidth := pmHeaders.Items[i].Tag;
                           if lvVMs.Items.Count < 10 then
                           begin
                              for j := 0 to lvVMS.Items.Count - 1 do
                                 lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                           end
                           else
                              for j := 0 to lvVMS.Items.Count - 1 do
                                 if j < 9 then
                                    lvVMS.Items[j].SubItems.Add('0' + IntToStr(j + 1))
                                 else
                                    lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                        end;
                     1:
                        begin
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].Name);
                        end;
                     2:
                        begin
                           ImageIndex := 3;
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].VMName);
                        end;
                     3:
                        begin
                           ImageIndex := 2;
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].FirstDriveName);
                        end;
                     4:
                        begin
                           ImageIndex := 2;
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].SecondDriveName);
                        end;
                  end;
                  Width := pmHeaders.Items[i].Tag;
               end;
      end
      else
      begin
         i := 1;
         while i < lvVMS.Columns.Count do
         begin
            if lvVMS.Columns[i].Tag = pmHeaders.Items.IndexOf(Sender as TMenuItem) then
            begin
               (Sender as TMenuItem).Tag := lvVMS.Columns[i].Width;
               lvVMS.Columns[i].Free;
               for j := 0 to lvVMS.Items.Count - 1 do
                  lvVMS.Items[j].SubItems.Delete(i - 1);
               Break;
            end;
            Inc(i);
         end;
      end;
   except
   end;
   lvVMS.Items.EndUpdate;
   lvVMs.Columns.EndUpdate;
   TntFormResize(Self);
   SaveCfg(CfgFile);
end;

procedure TFrmMain.Sort(const ColumnIndex: Integer);
var
   i, p: Integer;
   Changed, WasSorted: Boolean;
   et: VMEntry;
   li: TTNTListItem;
begin
   WasSorted := False;
   lvVms.Items.BeginUpdate;
   p := lvVMS.ItemIndex;
   try
      li := TTNTListItem.Create(lvVMS.Items);
      WasSorted := False;
      repeat
         Changed := False;
         for i := 0 to lvVMS.Items.Count - 2 do
         begin
            case CompareStringW((LOCALE_USER_DEFAULT or (SUBLANG_NEUTRAL shl 10)) or (SORT_DEFAULT shl 16), NORM_IGNORECASE, PWideChar(lvVMS.Items[i].SubItems[ColumnIndex - 1]), Length(lvVMS.Items[i].SubItems[ColumnIndex - 1]),
               PWideChar(lvVMS.Items[i + 1].SubItems[ColumnIndex - 1]), Length(lvVMS.Items[i + 1].SubItems[ColumnIndex - 1])) - 2 of
               1:
                  begin
                     if p = i then
                        p := i + 1
                     else if p = (i + 1) then
                        p := i;
                     li.Assign(lvVMs.Items[i + 1]);
                     lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
                     lvVMs.Items[i].Assign(li);
                     et := VMentries[i + 1];
                     VMentries[i + 1] := VMentries[i];
                     VMentries[i] := et;
                     Changed := True;
                     WasSorted := True;
                  end;
               0, -1:
            else
               Abort;
            end;
         end;
      until not Changed;
      li.Free;
      if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
      begin
         if lvVMs.Items.Count < 10 then
         begin
            for i := 0 to lvVMS.Items.Count - 1 do
               lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end
         else
            for i := 0 to lvVMS.Items.Count - 1 do
               if i < 9 then
                  lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
               else
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
      end;
   except
   end;
   lvVms.Items.EndUpdate;
   if p > -1 then
   begin
      lvVMS.ItemIndex := p;
      lvVMS.Items[p].Selected := True;
      lvVMS.Items[p].Focused := True;
      lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
   end;
   if WasSorted then
      SaveVMentries(VMentriesFile);
end;

procedure TFrmMain.SortAfterType;
var
   i, p: Integer;
   Changed, WasSorted, HasSubItems: Boolean;
   et: VMEntry;
   li: TTNTListItem;
begin
   WasSorted := False;
   HasSubItems := lvVMS.Columns.Count > 1;
   lvVms.Items.BeginUpdate;
   p := lvVMS.ItemIndex;
   try
      li := TTNTListItem.Create(lvVMS.Items);
      WasSorted := False;
      repeat
         Changed := False;
         for i := 0 to lvVMS.Items.Count - 2 do
            if (VMEntries[i].Ptype = 0) and (VMEntries[i + 1].Ptype = 1) then
            begin
               if p = i then
                  p := i + 1
               else if p = (i + 1) then
                  p := i;
               li.Assign(lvVMs.Items[i + 1]);
               lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
               lvVMs.Items[i].Assign(li);
               et := VMentries[i + 1];
               VMentries[i + 1] := VMentries[i];
               VMentries[i] := et;
               Changed := True;
               WasSorted := True;
            end
            else if HasSubItems and (VMEntries[i].Ptype = VMEntries[i + 1].Ptype) then
               case CompareStringW((LOCALE_USER_DEFAULT or (SUBLANG_NEUTRAL shl 10)) or (SORT_DEFAULT shl 16), NORM_IGNORECASE, PWideChar(lvVMS.Items[i].SubItems[0]), Length(lvVMS.Items[i].SubItems[0]),
                  PWideChar(lvVMS.Items[i + 1].SubItems[0]), Length(lvVMS.Items[i + 1].SubItems[0])) - 2 of
                  1:
                     begin
                        if p = i then
                           p := i + 1
                        else if p = (i + 1) then
                           p := i;
                        li.Assign(lvVMs.Items[i + 1]);
                        lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
                        lvVMs.Items[i].Assign(li);
                        et := VMentries[i + 1];
                        VMentries[i + 1] := VMentries[i];
                        VMentries[i] := et;
                        Changed := True;
                        WasSorted := True;
                     end;
                  0, -1:
               end;
      until not Changed;
      li.Free;
      if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
      begin
         if lvVMs.Items.Count < 10 then
         begin
            for i := 0 to lvVMS.Items.Count - 1 do
               lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end
         else
            for i := 0 to lvVMS.Items.Count - 1 do
               if i < 9 then
                  lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
               else
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
      end;
   except
   end;
   lvVms.Items.EndUpdate;
   if p > -1 then
   begin
      lvVMS.ItemIndex := p;
      lvVMS.Items[p].Selected := True;
      lvVMS.Items[p].Focused := True;
      lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
   end;
   if WasSorted then
      SaveVMentries(VMentriesFile);
end;

procedure TfrmMain.lvVMsColumnClick(Sender: TObject; Column: TListColumn);
begin
   if lvVMs.Items.Count > 1 then
      if Column.Tag > 0 then
         Sort(Column.Index)
      else if Column.Tag < 0 then
         SortAfterType;
end;

procedure TfrmMain.lvVMsContextPopup(Sender: TObject; MousePos: TPoint;
   var Handled: Boolean);
var
   iuc: TListItem;
   HeaderRect: TRect;
   Pos: TPoint;
begin
   Handled := True;
   GetWindowRect(ListView_GetHeader(lvVMs.Handle), HeaderRect);
   Pos := lvVMs.ClientToScreen(MousePos);
   if PtInRect(HeaderRect, Pos) then
      pmHeaders.Popup(Pos.X, Pos.Y)
   else
   begin
      if PtInRect(lvVMs.ClientRect, MousePos) then
      begin
         try
            iuc := lvVMs.GetItemAt(MousePos.X, MousePos.Y);
            if iuc <> nil then
            begin
               if not iuc.Selected then
                  iuc.Selected := True;
               if not iuc.Focused then
                  iuc.Focused := True;
               if lvVMs.ItemIndex <> iuc.Index then
                  lvVMs.ItemIndex := iuc.Index;
               if mmEditH.Enabled then
               begin
                  mmEditH.Enabled := False;
                  mmEdit.ShortCut := mmEditH.ShortCut;
                  mmEditH.ShortCut := 0;
                  mmEdit.Enabled := True;
               end;
               if mmDeleteH.Enabled then
               begin
                  mmDelete.ShortCut := mmDeleteH.ShortCut;
                  mmDeleteH.Enabled := False;
                  mmDeleteH.ShortCut := 0;
                  mmDelete.Enabled := True;
               end;
               if mmMoveUpH.Enabled then
               begin
                  mmMoveUpH.Enabled := False;
                  mmMoveUp.ShortCut := mmMoveUpH.ShortCut;
                  mmMoveUpH.ShortCut := 0;
                  mmMoveUp.Enabled := True;
               end;
               if mmMoveDownH.Enabled then
               begin
                  mmMoveDown.ShortCut := mmMoveDownH.ShortCut;
                  mmMoveDownH.Enabled := False;
                  mmMoveDownH.ShortCut := 0;
                  mmMoveDown.Enabled := True;
               end;
            end
            else
            begin
               if mmEdit.Enabled then
               begin
                  mmEdit.Enabled := False;
                  mmEditH.ShortCut := mmEdit.ShortCut;
                  mmEdit.ShortCut := 0;
                  mmEditH.Enabled := True;
               end;
               if mmDelete.Enabled then
               begin
                  mmDeleteH.ShortCut := mmDelete.ShortCut;
                  mmDelete.Enabled := False;
                  mmDelete.ShortCut := 0;
                  mmDeleteH.Enabled := True;
               end;
               if mmMoveUp.Enabled then
               begin
                  mmMoveUp.Enabled := False;
                  mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
                  mmMoveUp.ShortCut := 0;
                  mmMoveUpH.Enabled := True;
               end;
               if mmMoveDown.Enabled then
               begin
                  mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
                  mmMoveDown.Enabled := False;
                  mmMoveDown.ShortCut := 0;
                  mmMoveDownH.Enabled := True;
               end;
            end;
         except
            if mmEdit.Enabled then
            begin
               mmEdit.Enabled := False;
               mmEditH.ShortCut := mmEdit.ShortCut;
               mmEdit.ShortCut := 0;
               mmEditH.Enabled := True;
            end;
            if mmDelete.Enabled then
            begin
               mmDeleteH.ShortCut := mmDelete.ShortCut;
               mmDelete.Enabled := False;
               mmDelete.ShortCut := 0;
               mmDeleteH.Enabled := True;
            end;
            if mmMoveUp.Enabled then
            begin
               mmMoveUp.Enabled := False;
               mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
               mmMoveUp.ShortCut := 0;
               mmMoveUpH.Enabled := True;
            end;
            if mmMoveDown.Enabled then
            begin
               mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
               mmMoveDown.Enabled := False;
               mmMoveDown.ShortCut := 0;
               mmMoveDownH.Enabled := True;
            end;
         end;
         pmVMs.Popup(Pos.X, Pos.Y);
      end
      else if (MousePos.X = -1) and (MousePos.Y = -1) then
      begin
         if mmEdit.Enabled then
         begin
            mmEdit.Enabled := False;
            mmEditH.ShortCut := mmEdit.ShortCut;
            mmEdit.ShortCut := 0;
            mmEditH.Enabled := True;
         end;
         if mmDelete.Enabled then
         begin
            mmDeleteH.ShortCut := mmDelete.ShortCut;
            mmDelete.Enabled := False;
            mmDelete.ShortCut := 0;
            mmDeleteH.Enabled := True;
         end;
         if mmMoveUp.Enabled then
         begin
            mmMoveUp.Enabled := False;
            mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
            mmMoveUp.ShortCut := 0;
            mmMoveUpH.Enabled := True;
         end;
         if mmMoveDown.Enabled then
         begin
            mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
            mmMoveDown.Enabled := False;
            mmMoveDown.ShortCut := 0;
            mmMoveDownH.Enabled := True;
         end;
         Pos := Point(lvVMs.ClientOrigin.X + lvVMs.ClientWidth div 2, lvVMs.ClientOrigin.Y + lvVMs.ClientHeight div 2);
         pmVMs.Popup(Pos.X, Pos.Y);
      end;
   end;
end;

procedure GetColors(const BaseColor: TColor; const Range: Byte; var c1, c2: TColor);

   procedure MinMax3(const i, j, k: Integer; var min, max: Integer);
   begin
      if i > j then
      begin
         if i > k then
            max := i
         else
            max := k;

         if j < k then
            min := j
         else
            min := k
      end
      else
      begin
         if j > k then
            max := j
         else
            max := k;

         if i < k then
            min := i
         else
            min := k
      end
   end;

const
   divisor: Integer = 255 * 60;
var
   Delta: Integer;
   MinValue: Integer;
   r, g, b, c, h, s, v, v1, v2, f, hTemp, p, q, t: Integer;
begin
   c := ColorToRGB(BaseColor);
   r := GetRValue(c);
   g := GetGValue(c);
   b := GetBValue(c);
   MinMax3(R, G, B, MinValue, v);
   Delta := v - MinValue;
   h := 0;
   if v = 0 then
      s := 0
   else
      s := (255 * Delta) div v;
   if s = 0 then
      h := 0
   else
   begin
      if r = v then
         h := (60 * (g - b)) div Delta
      else if g = v then
         h := 120 + (60 * (b - r)) div Delta
      else if b = v then
         h := 240 + (60 * (r - g)) div Delta;

      if h < 0 then
         h := h + 360;
   end;

   if v <= 127 then
   begin
      if (v >= Range) and (v<=(255 - Range)) then
      begin
         v1 := v - Range;
         v2 := v + Range;
      end
      else if v > 245 then
      begin
         v1 := 255 - 2 * Range;
         v2 := 255;
      end
      else
      begin
         v1 := 0;
         v2 := 2 * Range;
      end;
   end
   else
   begin
      if (v >= Range) and (v<=(255 - Range)) then
      begin
         v1 := v + Range;
         v2 := v - Range;
      end
      else if v>(255 - Range) then
      begin
         v1 := 255;
         v2 := 255 - 2 * Range;
      end
      else
      begin
         v1 := 2 * Range;
         v2 := 0;
      end;
   end;

   if s = 0 then
   begin
      r := v1;
      g := v1;
      b := v1;
   end
   else
   begin
      if h = 360 then
         hTemp := 0
      else
         hTemp := h;

      f := hTemp mod 60;
      hTemp := hTemp div 60;

      p := v1 - v1 * s div 255;
      q := v1 - (v1 * s * f) div divisor;
      t := v1 - (v1 * s * (60 - f)) div divisor;

      case hTemp of
         0:
            begin
               r := v1;
               g := t;
               b := p;
            end;
         1:
            begin
               r := q;
               g := v1;
               b := p;
            end;
         2:
            begin
               r := p;
               g := v1;
               b := t;
            end;
         3:
            begin
               r := p;
               g := q;
               b := v1;
            end;
         4:
            begin
               r := t;
               g := p;
               b := v1;
            end;
         5:
            begin
               r := v1;
               g := p;
               b := q;
            end;
      else
         begin
            r := v1;
            g := v1;
            b := v1;
         end
      end
   end;
   c1 := RGB(r, g, b);

   if s = 0 then
   begin
      r := v2;
      g := v2;
      b := v2;
   end
   else
   begin
      if h = 360 then
         hTemp := 0
      else
         hTemp := h;

      f := hTemp mod 60;
      hTemp := hTemp div 60;

      p := v2 - v2 * s div 255;
      q := v2 - (v2 * s * f) div divisor;
      t := v2 - (v2 * s * (60 - f)) div divisor;

      case hTemp of
         0:
            begin
               r := v2;
               g := t;
               b := p;
            end;
         1:
            begin
               r := q;
               g := v2;
               b := p;
            end;
         2:
            begin
               r := p;
               g := v2;
               b := t;
            end;
         3:
            begin
               r := p;
               g := q;
               b := v2;
            end;
         4:
            begin
               r := t;
               g := p;
               b := v2;
            end;
         5:
            begin
               r := v2;
               g := p;
               b := q;
            end;
      else
         begin
            r := v2;
            g := v2;
            b := v2;
         end
      end
   end;
   c2 := RGB(r, g, b);
end;

procedure TfrmMain.lvVMsCustomDrawSubItem(Sender: TCustomListView;
   Item: TListItem; SubItem: Integer; State: TCustomDrawState;
   var DefaultDraw: Boolean);
var
   c1, c2: TColor;
begin
   try
      GetColors(Sender.Canvas.Font.Color, 40, c1, c2);
      if SubItem <= Ceil(0.5 * Item.SubItems.Count) then
         Sender.Canvas.Font.Color := c1
      else
         Sender.Canvas.Font.Color := c2;
   except
      Sender.Canvas.Font.Color := (Sender as TTntListView).Font.Color;
   end;
   if (Sender as TTntListView).Items.Count < 5 then
      Exit;
   try
      if Active then
      begin
         GetColors(Sender.Canvas.Brush.Color, 8, c1, c2);
         if (Item.Index mod 2) = 0 then
            Sender.Canvas.Brush.Color := c1
         else
            Sender.Canvas.Brush.Color := c2;
      end;
   except
      Sender.Canvas.Brush.Color := (Sender as TTntListView).Color;
   end;
end;

procedure TfrmMain.AppActDeactModBegModEnd(Sender: TObject);
begin
   if Showing then
      lvVMs.Invalidate;
end;

procedure TfrmMain.mmDownClick(Sender: TObject);
begin
   if lvVMs.Items.Count < 1 then
      Exit;
   if lvVMs.ItemIndex<(lvVMs.Items.Count - 1) then
      lvVMs.ItemIndex := lvVMs.ItemIndex + 1
   else
      lvVMs.ItemIndex := 0;
   lvVMs.Items[lvVMs.ItemIndex].Selected := True;
   lvVMs.Items[lvVMs.ItemIndex].Focused := True;
end;

procedure TfrmMain.mmUpClick(Sender: TObject);
begin
   if lvVMs.Items.Count < 1 then
      Exit;
   if lvVMs.ItemIndex > 0 then
      lvVMs.ItemIndex := lvVMs.ItemIndex - 1
   else
      lvVMs.ItemIndex := lvVMs.Items.Count - 1;
   lvVMs.Items[lvVMs.ItemIndex].Selected := True;
   lvVMs.Items[lvVMs.ItemIndex].Focused := True;
end;

procedure TfrmMain.mmEnterClick(Sender: TObject);
begin
   btnStart.Click;
end;

procedure TfrmMain.mmEscClick(Sender: TObject);
begin
   btnExit.Click;
end;

procedure TfrmMain.mmNumPlusClick(Sender: TObject);
begin
   btnAdd.Click;
end;

procedure TfrmMain.btnOptionsClick(Sender: TObject);
var
   i, j: Integer;
begin
   btnOptions.Down := True;
   try
      try
         if frmOptions = nil then
            Application.CreateForm(TfrmOptions, frmOptions);
         with frmOptions do
         begin
            cbLock.Checked := LockVolumes;
            cbSecondDrive.Checked := AddSecondDrive;
            edtWaitTime.Text := IntToStr(FlushWaitTime);
            cbBackup.Checked := BackupOldEntries;
            cbDontWarn.Checked := DontWarn;
            if DefaultVMType = 1 then
               rbQEMU.Checked := True;
            edtVBExePath.Text := ExeVBPath;
            cbUseVboxmanage.Checked := UpdateVM = 0;
            cbDirectly.Checked := not cbUseVboxmanage.Checked;
            cbCPUVirtualizationOption.Checked := ShowVBCPUVirtualizationOption;
            edtQExePath.Text := ExeQPath;
            edtDefaultParameters.Text := QEMUDefaultParameters;
            if ShowModal = mrOK then
            begin
               LockVolumes := cbLock.Checked;
               if AddSecondDrive <> cbSecondDrive.Checked then
                  if cbSecondDrive.Checked then
                  begin
                     pmHeaders.Items[4].Visible := True;
                     pmHeaders.Items[3].Caption := 'First drive';
                     for i := 1 to lvVms.Columns.Count - 1 do
                        if lvVms.Columns[i].Tag = 3 then
                        begin
                           lvVms.Columns[i].Caption := 'First drive';
                           Break;
                        end;
                     pmHeadersPopup(pmHeaders);
                     pmHeaders.Items[4].Click;
                  end
                  else
                  begin
                     for i := 0 to lvVms.Items.Count - 1 do
                     begin
                        VMentries[i].SecondDriveID := '';
                        VMEntries[i].SecondDriveName := '';
                     end;
                     SaveVMentries(VMentriesFile);
                     lvVMs.Items.BeginUpdate;
                     lvVMs.Columns.BeginUpdate;
                     pmHeaders.Items[3].Caption := 'Drive';
                     for i := 1 to lvVms.Columns.Count - 1 do
                        if lvVms.Columns[i].Tag = 3 then
                        begin
                           lvVms.Columns[i].Caption := 'Drive';
                           Break;
                        end;
                     i := 1;
                     while i < lvVms.Columns.Count do
                     begin
                        if lvVms.Columns[i].Tag = 4 then
                           Break;
                        Inc(i);
                     end;
                     if i < lvVms.Columns.Count then
                        try
                           i := 1;
                           while i < lvVMS.Columns.Count do
                           begin
                              if lvVMS.Columns[i].Tag = 4 then
                              begin
                                 pmHeaders.Items[4].Tag := lvVMS.Columns[i].Width;
                                 lvVMS.Columns[i].Free;
                                 for j := 0 to lvVMS.Items.Count - 1 do
                                    lvVMS.Items[j].SubItems.Delete(i - 1);
                                 Break;
                              end;
                              Inc(i);
                           end;
                        except
                        end;
                     pmHeaders.Items[4].Visible := False;
                     lvVMS.Items.EndUpdate;
                     lvVMs.Columns.EndUpdate;
                     TntFormResize(Self);
                  end;
               AddSecondDrive := cbSecondDrive.Checked;
               FlushWaitTime := Min(Max(StrToIntDef(Trim(edtWaitTime.Text), 500), 0), 20000);
               BackupOldEntries := cbBackup.Checked;
               DontWarn := cbDontWarn.Checked;
               DefaultVMType := Integer(rbQEMU.Checked);
               ExeVBPath := Trim(edtVBExePath.Text);
               UpdateVM := Integer(cbDirectly.Checked);
               ShowVBCPUVirtualizationOption := cbCPUVirtualizationOption.Checked;
               ExeQPath := Trim(edtQExePath.Text);
               QEMUDefaultParameters := Trim(edtDefaultParameters.Text);
               SaveCFG(CfgFile);
            end;
         end;
      finally
         frmOptions.Free;
         frmOptions := nil;
      end;
   except
   end;
   btnOptions.Down := False;
end;

procedure TfrmMain.mmHelpClick(Sender: TObject);
begin
   frmMain.OpenInternetHelp(Self.Handle, DefSiteHelp);
end;

procedure TfrmMain.mmOptionsClick(Sender: TObject);
begin
   btnOptions.Click;
end;

procedure TfrmMain.OnException(Sender: TObject; E: Exception);
begin
   try
   except
   end;
end;

function TfrmMain.FindCDROMLetter(const CDROMName: AnsiString): Char;
var
   objWMIService: OLEVariant;
   colItems: OLEVariant;
   colItem: OLEVariant;
   oEnum: IEnumvariant;
   iValue: LongWord;
   i, j: Integer;
   isFound: Boolean;
   s: AnsiString;

   function GetWMIObject(const objectName: AnsiString): IDispatch;
   var
      chEaten: Integer;
      BindCtx: IBindCtx;
      Moniker: IMoniker;
   begin
      OleCheck(CreateBindCtx(0, bindCtx));
      OleCheck(MkParseDisplayName(BindCtx, StringToOleStr(objectName), chEaten, Moniker));
      OleCheck(Moniker.BindToObject(BindCtx, nil, IDispatch, Result));
   end;
begin
   Result := '0';
   if Succeeded(CoInitialize(nil)) then
      try
         try
            objWMIService := GetWMIObject(Format('winmgmts:\\%s\%s', ['.', 'root\CIMV2']));
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Caption', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            i := 0;
            isFound := False;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if AnsiString(colItem.Properties_.Item('Caption', 0)) = CDROMName then
               begin
                  isFound := True;
                  Break;
               end;
               Inc(i);
            end;
            if not isFound then
               Exit;
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Drive', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            j := 0;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if i = j then
               begin
                  s := colItem.Properties_.Item('Drive', 0);
                  if (Length(s) = 2) and (s[2] = ':') and (s[1] in ['A'..'Z']) then
                     Result := s[1];
                  Break;
               end;
               Inc(j);
               if j > i then
                  Break;
            end;
         except
         end;
      finally
         CoUninitialize;
      end;
end;

end.

